/* Buffer union / struct definition  */
/* TJW 960416                        */
/* I hope this helps cleaning up the */
/* buffer-"pointer" mess in BT ;-)   */

#ifndef _BUFFER_H_INCLUDED
#define _BUFFER_H_INCLUDED

/*------------------------- Buffer layout graphically -----------------------

v Secbuf
v Txbuf
|---------------------------- WAZOOMAX + 16 ----------------------------|
                              8192+16=8208

Hydra:
v txbuf                              v rxbuf
|---------- H_BUFLEN ---------------||-------- H_MAXPKTLEN ----------------|
    (2048+8+5)*3+16=6199                       (2048+8+5)*3=6183

hydra.h:
#define H_MAXBLKLEN  2048                    Max. length of a HYDRA data block
#define H_OVERHEAD      8                    Max. no. control bytes in a pkt
#define H_MAXPKTLEN  ((H_MAXBLKLEN + H_OVERHEAD + 5) * 3)      Encoded pkt
#define H_BUFLEN     (H_MAXPKTLEN + 16)      Buffer sizes: max.enc.pkt + slack

Janus:
v Txbuf                              v Rxbuf               v Rxbufmax
|----------4096+8-------------------||------BUFMAX+8-------|
                                            2048+8=2056

---------------------------------------------------------------------------*/

#ifndef _ZMODEM_H_INCLUDED
#include "zmodem.h"
#endif
#ifndef _HYDRA_H_INCLUDED
#include "hydra.h"
#endif
#ifndef _JANUS_H_INCLUDED
#include "janus.h"
#endif

#define TOTALBUFSIZE (WAZOOMAX+16)

#define TXBUFSIZE (TOTALBUFSIZE)
#define SECBUFSIZE (1500)
#define POPBUFSIZE (1) /* ??? */

#define HYDRATXBUFSIZE (H_MAXBLKLEN+H_OVERHEAD+5)
#define HYDRARXBUFSIZE (H_MAXPKTLEN)

#define JANUSTXBUFSIZE (4096+8)   /* ??? */
#define JANUSRXBUFSIZE (BUFMAX+8) /* ??? */

typedef union{
  byte pumpitup[20000];
  byte _all[TOTALBUFSIZE];         /* at least WAZOOMAX+16 */
  byte _Txbuf[TXBUFSIZE];
  struct{
    byte _Secbuf[SECBUFSIZE]; /* or up to WAZOOMAX ! */
    byte _popbuf[POPBUFSIZE];
  } b_initva;
  struct{
    byte _p[2048];
    byte _q[1];     /* ? */
  } extmail;
  struct{
    char _junkbuff[4096];
    char _uni[256];
    char _help[256];
    char _tmpstr[2560];
    char _pq[1040]; /* ? */
  } emsi;
  struct{
    byte _txbuf[HYDRATXBUFSIZE*2];
    byte _txbufin[HYDRATXBUFSIZE];
    byte __dummy[16];
    byte _rxbuf[HYDRARXBUFSIZE];
  } hydra;
  struct{
    byte _Txbuf[JANUSTXBUFSIZE];
    byte _Rxbuf[JANUSRXBUFSIZE];
  } janus;
} BUF;

#endif /* _BUFFER_H_INCLUDED */
