#if !defined (_CSS_H)
#define _CSS_H

typedef struct XferStats
{
    char fname[13]; /*  current filename, zero terminated, init/invalid: \0 */
    long FilePos;   /*  offset in file being transfered,   init/invalid: -1 */
    long FileLen;   /*  of file being transferred          init/invalid: -1 */
    long tot_moh;   /*  total mail on hold,                init/invalid: 0  */
                    /*  (this is what we sent/got in EMSI and normally      */
                    /*  constant                                            */
    long tot_files; /*  total  number of files             init/invalid: 0  */
    long cur_moh;   /*  current mail on hold               init/invalid: 0  */
                    /*  (remains constant while a file is transferred)      */
                    /*  init: same as tot_moh, then after a file is         */
                    /*  successfully transferred: -=FileLen                 */
    long cur_files; /*  current remaining number of files  init/invalid: 0  */
    int cur_cps;    /*  current cps rate                   init/invalid: 0  */
    int low_cps;    /*  lowest  cps rate so far            init/invalid: 0  */
    int high_cps;   /*  highest cps rate so far            init/invalid: 0  */
    int tot_cps;    /*  total   cps rate so far            init/invalid: 0  */
    int cur_errors; /*  current errors                     init/invalid: 0  */
    int tot_errors; /*  total   errors                     init/invalid: 0  */
    long cur_time;  /*  seconds remaining current file     init/invalid: 0  */
    long tot_time;  /*  seconds remaining all files        init/invalid: 0  */

} XFERSTATS, *XFERSTATSP;

void css_init(void);
void css_upd(void);
void css_done(void);

extern XFERSTATS TxStats, RxStats;   /* global */

#endif                                                /*  !defined (_CSS_H) */
