/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*              (C) Copyright 1987-96, Bit Bucket Software Co.              */
/*                                                                          */
/*                                                                          */
/*                                                                          */
/*                Prototype definitions used in BinkleyTerm                 */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.260.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:42/1491                        */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#ifdef NEED_WRITE_ANSI
void WRITE_ANSI (char);
#endif
#ifdef NEED_DOSREAD
int _dos_read (int, void far *, unsigned, unsigned int *);
int _dos_write (int, void far *, unsigned, unsigned int *);
#endif

#ifdef NEED_CPUTS
int _cdecl cputs (const char *);
#endif

#ifdef NEED_PUTCH
int _cdecl putch (int);
#endif

#ifdef NEED_CPRINTF
int _cdecl cprintf (const char *,...);
#endif

#ifdef NEED_KBHIT
int kbhit(void);
#endif

#ifdef NEED_MKTEMP
extern char *mktemp (char *);
#endif

#ifdef BINKLEY_SOUNDS
extern void Make_Sound (char *);
#endif

#ifdef DOS16
int _cdecl real_flush (int);
#endif

#ifdef OS_2
void set_fileinfo (int, unsigned, unsigned);
#endif  /* OS_2  */

#ifdef Snoop

#if defined(__IBMC__) || (defined(__WATCOMC__) && defined(__FLAT__))
short _Far16 _Pascal mesgfunc (short error, char * _Seg16 mesq);
/* TJW 961010 removed "_Far16" qualifier from mesq as this is for FUNCTIONS */
/* if this does not work with WATCOM, too, use char * _Seg16 _Far16 mesq    */
#else   /* #ifdef __IBMC__ */
#if defined (OS_2) && defined (__BORLANDC__)
short __far16 __pascal mesgfunc (short error, char * __far16 __far16 mesq);
#else
static int far pascal _loadds mesgfunc (int error, char far * mesq);
#endif  /* __BORLANDC__ and OS_2 */
#endif  /* #ifdef __IBMC__ */

void snoop_open (char *pipename);
void snoop_close (void);
#endif  /* Snoop */

struct _key_fnc_hdr *KbMapSet (struct _key_fnc_hdr *KeyFncHdr);
void com_kick (void);
void b_sbinit (void);
void b_sbexit (void);
void sb_clean (void);
void sb_dirty (void);
void sb_init (void);
void sb_exit (void);
int sb_input_chars (REGIONP, short, short, char *, short);
int sb_input_fname (REGIONP, short, short, char *, short);  /* RDH */
REGIONP sb_new (short, short, short, short);
int sb_popup (short, short, short, short, int (*)(BINK_SAVEP, int), int);
int sb_putc (REGIONP, short);
int sb_putc_abs (REGIONP, short);
void sb_restore (BINK_SAVEP);
BINK_SAVEP sb_save (short, short, short, short);
void sb_show (void);
REGIONP sb_new_win (short top, short left, short height, short width, /* sb_new     */
                   short fch, short fattr,                            /* sb_fill    */
                   short btype, short battr,                          /* sb_box     */
                   char *Caption);                                    /* sb_caption */

unsigned short pascal KbRemap (unsigned short ScanCode);
void sb_box (REGIONP, short, short);
void sb_caption (REGIONP, char *);
void sb_fill (REGIONP, short, short);
void sb_filla (REGIONP, short);
void sb_fillc (REGIONP, short);
void sb_move (REGIONP, short, short);
void sb_move_abs (REGIONP, short, short);
void sb_puts (REGIONP, char *);
void sb_puts_abs (REGIONP, char *);
void sb_move_puts (REGIONP, short, short, char *);
void sb_move_puts_abs (REGIONP, short, short, char *);
#if 0 /* unused */
unsigned char sb_ra (REGIONP, short, short);
unsigned char sb_rc (REGIONP, short, short);
unsigned int sb_rca (REGIONP, short, short);
#endif
void sb_scrl (REGIONP, short);
void sb_wa (REGIONP, short, short);
void sb_wa_abs (REGIONP, short, short);
void sb_wc (REGIONP, short, short);
void sb_wc_abs (REGIONP, short, short);
void sb_wca (REGIONP, short, short, short);
void sb_wca_abs (REGIONP, short, short, short);

int Do_Get (BINK_SAVEP, int);
int Do_Send (BINK_SAVEP, int);
int Do_Kill (BINK_SAVEP, int);
int Do_Poll (BINK_SAVEP, int);
int Do_Poll_Packet (BINK_SAVEP, int);
int Do_Zoom (BINK_SAVEP, int);

int Upload (char *, int, char *);
int Download (char *, int, char *);

void set_prior (int);
int load_language (char *exe);  /* MMP 960420 Added exe argument */
void b_initvars (void);
void b_defaultvars (void);
void b_exitproc (void);
int got_ESC (void);
void BBSexit (void);
long timerset (unsigned int);
int timeup (long);
void dostime (int *, int *, int *, int *);
void _cdecl time_release (void);
void fossil_gotoxy (int, int);
int fossil_wherex (void);
int fossil_wherey (void);
unsigned _cdecl dos_box_active (void);
unsigned _cdecl windows_active (void);
unsigned _cdecl dv_get_version (void);
unsigned _cdecl tv_get_version (void);
unsigned _cdecl ddos_active (void);
unsigned _cdecl ml_active (void);
unsigned _cdecl mos_active (void);
void dos_break_off (void);
void mtask_find (void);
void _cdecl windows_pause (void);
void _cdecl mos_pause (void);
void _cdecl dv_pause (void);
void _cdecl ddos_pause (void);
void _cdecl tv_pause (void);
void _cdecl ml_pause (void);
void _cdecl msdos_pause (void);
void _cdecl os2_pause (void);
void _cdecl status_line (char *,...);
int time_to_next (int);
void write_sched (void);
void close_up (void);
void scr_printf (char *);
int SendBanner (char far *);
void opening_banner (void);
void mailer_banner (void);
void UUCPexit (int, int);
void come_back (void);
char *fancy_str (char *);
int got_error (char *, char *);
int dfind (struct FILEINFO *, char *, int);
int n_frproc (char *, int, int (*)(char *), int (*)(long));
void Make_Response (char *, int);
int do_FLOfile (char *, int (*)(char *));
void fidouser (char *, ADDR *);
void opususer (char *, ADDR *);
void main_help (void);
void mailer_help (void);
int n_password (char *, char *, int *);
int n_getpassword (ADDR *);
int nodefind (ADDR *, int);
void do_extern (char *, int, char *);
int dexists (char *);
int do_script (char *);
void timer (int);
void mdm_cmd_string (char *, int);
void send_break (int);
void mdm_cmd_char (int);
int modem_response (int);
char *get_response (long, int);
int set_baud (unsigned long, int);
void program_baud (void);
int list_search (void);
int checklist (void);
int nodeproc (char *);
int try_1_connect (char *);
void gong (void);
void b_init (void);
void b_session (int);
void b_session_cleanup (void);             /* TJW 960805 */
void do_ready (int);
int FTSC_receiver (int);
int Whack_CR (void);
void FTSC_sender (int);
int YooHoo_Receiver (void);
void last_type (int, ADDR *);
void WaZOO (int);
void EMSI (int);
int YooHoo_Sender (void);
int get_Zmodem (char *, FILE *);
int Send_Zmodem (char *, char *, int, int);
int send_WaZOO (void);
int send_EMSI (void);
int respond_to_file_requests (int, int (*)(char *), int (*)(long));
void mdm_hangup (void);
void Janus (void);
void invent_pkt_name (char *);
int send_Hello (int);
void set_xy (char *);
char *receive_file (char *, char *, char);
void read_sched (void);
void parse_config (char *);
char *ctl_string (char *);
char *ctl_slash_string (char *);
int parse (char *, struct parse_list far *);
void bottom_line (void);
void do_today (int doshowflag);
void boss_mail (int);
int unattended (void);
int get_number (char *);
void try_2_connect (char *);
void change_prompt (void);
int do_mail (ADDR *, int);
void ansi_map (unsigned int);
void mdm_init (char *);
void fossil_ver (void);
char *zalloc (void);
int xfermdm7 (char *);
int send_file (char *, char);
int recvmdm7 (char *);
MAINTYPE main (int, char **);
int opusfind (ADDR *, int);
int ver7find (ADDR *, int);

#ifdef QUICK_LIST
int QuickLookup (ADDR *, int);
#endif

int TBBSLookup (ADDR *, int);
char *skip_blanks (char *);
char *skip_to_blank (char *);
char *skip_to_word (char *);
int parse_event (char *);
void SEA_sendreq (void);
int try_sealink (void);
int SEA_recvreq (void);
void clear_filetransfer (void);
long throughput (int, unsigned long);
char *numdisp (long);
int is_arcmail (char *, int);
void send_can (void);
int bad_call (ADDR *, int);
void receive_exit (void);
void xmit_sameplace (void);

void find_event (void);
void errl_exit (int);
void errl_shell (int);
long random_time (int);
int handle_inbound_mail (int);
void xmit_reset (int, int);
int xmit_next (ADDR *);
void kill_bad (void);
void put_up_time (void);
void adios (int);
void big_pause (int);
long zfree (char *);
void show_debug_name (char *);
char *check_netfile (char *);
void unique_name (char *);
void write_sched (void);
void z_message (char *);
int Z_GetByte (int);
void Z_PutString (unsigned char *);
void Z_SendHexHeader (unsigned int, unsigned char *);
int Z_GetHeader (unsigned char *);
int Z_GetZDL (void);
void Z_PutLongIntoHeader (long);
void z_log (char *);
void show_loc (unsigned long, unsigned int);
void Z_UncorkTransmitter (void);
void z_log (char *);
char *add_backslash (char *);
char *delete_backslash (char *);
void vfossil_init (void);
void vfossil_close (void);
void vfossil_cursor (int);
MAILP find_mail (ADDR *);
void xmit_window (MAILP);
void xmit_delete (void);
char *HoldAreaNameMunge (ADDR *);
int LoadScanList (int, int);
void swapper (char far *, char far *, int, char far *, unsigned);
void b_spawn (char *);
void do_dial_strings (void);
void exit_DTR (void);
void delete_old_file (char *);
long cost_of_call (int, long, long);
void update_files (int , char *, long, long, long);
void screen_clear (void);
void clear_eol (void);
void log_product (int, int, int);
int b_term (void);
void set_up_outbound (int);
int is_user (char *);
int next_minute (void);
void can_Janus (char *);
int Modem7_Receive_File (char *);
int Modem7_Send_File (char *);
int Batch_Receive (char *);
int Batch_Send (char *);
int Xmodem_Send_File (char *, char *);
int Xmodem_Receive_File (char *, char *);
int SEAlink_Send_File (char *, char *);
int Telink_Send_File (char *, char *);
unsigned short crc_block (unsigned char *, int);
void Data_Check (XMDATAP, int);
void wait_for_key (int);
void Get_Block (XMARGSP);
int Xmodem_Send (int, int, long);
void Send_Block (XMARGSP);
int calc_window (void);
int Receive_Resync (long *);
void Xmodem_Error (char *, long);
int Header_in_data (unsigned char *);
void Find_Char (int);
int Xmodem_Receive (int, char *);
void Send_Response (int, int *, int *, int *, long, int, long);
void Set_Up_Telink (XMDATAP, TLDATAP, long *);
void End_Telink (int, TLDATAP, XMDATAP, char *, int);
void Wait_Clear (int);
void Send_Resync (long, int);
int state_machine (STATEP, void *, int);
int Bark_Request (char *, char *, char *, char *);
void Build_Bark_Packet (BARKARGSP);
int Receive_Bark_Packet (BARKARGSP);
int Batch_Xmodem_Receive_File (char *, char *);
long Set_Up_Restart (XMARGSP);
void Finish_Xmodem_Receive (XMARGSP);
void Get_Telink_Info (XMARGSP);
int Read_Block (XMARGSP);
void Check_ACKNAK (XMARGSP);
void show_block (long, char *, XMARGSP);
int check_failed (char *, char *, char *, char *);
void add_abort (char *, char *, char *, char *, char *);
void remove_abort (char *, char *);
void Build_Header_Block (XMARGSP, char);
void show_sending_blocks (XMARGSP);
char *show_num (XMARGSP, long);
void elapse_time (int show);
int parse_address (char *, ADDR *);
int find_address (char *, ADDR *);
char *Hex_Addr_Str (ADDR *);
char *Full_Addr_Str (ADDR *);
char *add_domain (char *);
char *find_domain (char *);
int flag_file (int, ADDR *, int);
int term_overlay (short);
void write_stats (void);
void list_next_event (void);
int machine (STATEP, void *, int);
int share_open (char *, int, int);
FILE *share_fopen (char *, char *, int);
void forcexitcheck (void);
int forcerescancheck (void);
int show_alive(void);
int faxreceive (int);
int SquishScan(char *);

/* TJW 961010 IPC interface */
void IPC_Ping(void);
void IPC_SetStatus(char *);
int  IPC_Open(void);
void IPC_Close(void);

/* MMP 960419 - b_logs.c */
char *status_log_path(void);
char *cost_log_path(void);
void timesync(void);

void openlogs(int newlineflag); /* TJW 960527 */
void closelogs(void);           /* TJW 960527 */
void movelogs(void);
void binkexit(int n);

/* MMP 960513 - cache.c */
void dirinit(DIRBUF *buf, char *mask);
int dirread(DIRBUF *buf);
void dirquit(DIRBUF *buf, int flush);
int cachedump(char *path);
void cacheflush(void);
int cachestat(char *path, struct stat *buf, DIRECTORY **dirp, DIRENTRY **entp,
              long freqfilesize);
long cachenetsize(MAILP p);

int freepoll (char *);      /* CE 960423 */

int invoke_SRIF(int, int (*) (char*), int (*) (long)); /* mtt 960429 */
void change_call_to_normal (ADDRP addr); /* CE 960506 */

void b_sbinit(void);

void heapchk(void);

void timedisplay(void);     /* TJW 960624 */

long totalsize(ADDRP addr);    /* get size of all mail for addr */ 

void chat_init(void);        /* TJW 960704 chat functions */
void chat_exit(void);
void chat_put_local(char *s);
void chat_put_remote(char *s);
void chat_put(REGIONP w, char *s);
void chat_prepare(void);

void redraw_callwin(void);

BINK_EVENTP find_costevent(long t); /* TJW 960721 */

void fossil_announce(int fs);       /*  TS 960725   */

void read_in_log(void);             /* TJW 960724 */

void log_screen(char *, char *);    /* TJW 960724 */

void calc_cost(int caller, long s, long e,              /* TJW 960728 */  
               long *_dt, long *_totcost, long *tot_rcost, word *_cost);
              
char mail_stat (MAILP);             /* TJW 960731 */

void global_rescan(void);           /* TJW 960731 */

long custom_date(struct tm *);      /* TJW 960804 */

void cleanup_req(char *fname);      /* TJW 960808 */

int eval(char *s);                  /* TJW 960830 */

void append_pkt (REGIONP, unsigned int, char *, char *);

BOOL keyabort(void);

#ifdef ANSI_TIME_T
int         ansi_stat(const char *fname, struct stat *buffer);
int         ansi_fstat(int handle, struct stat *buffer);
time_t      ansi_time(time_t *timeptr);
time_t      ansi_mktime(struct tm *time);
struct tm * ansi_localtime(const time_t *timeval);
struct tm * ansi_gmtime(const time_t *timeval);
char *      ansi_ctime(const time_t *timeval);
int         ansi_utime(char *fname, struct utimbuf *buf);
#endif
