#
#   makefile for BTXE project using IBM NMAKE and the emx 2.7.2 compiler
#   with 0.9b#5 runtime under os/2 by tom schlangen.
#
#   please notice that this makefile is still under construction and
#   not yet suitable for general distribution.
#
#   instead using macro magic to circumvent the 1024 char command line
#   limit of os/2, i prefered to use an object library for linking
#   purposes.
#
#   the file `binkley.rsp' is a response file to the emxomfar librarian
#   and contains a list of modules to put into the lib file.
#

ADDINCS= -I..\include
ADDLIBS= -L..\lib -L. -lbinkley -lmaxcomm -lmcp32
OPTFLAGS= -s -O2
DBGFLAGS= -g
DEFFLAGS= -DNEED_SET_PRIOR -DOS_2 -DHYDRADEV -DPROMETER
INCDIR=..\include
SRCDIR=..\src
#LNKFLAGS= -Zlinker "/map /noi /nol /pm:vio /align:16 /base:65536 /stack:32768 /exepack"
LNKFLAGS= -Zlinker "/map /noi /nol /pm:vio /align:16 /base:65536 /stack:32768 /exepack"

#   optimized, no debug, no snoop:
CFLAGS= -Wall -Zsys -Zomf $(OPTFLAGS) $(DEFFLAGS) $(ADDINCS)
#   no optimization, debug, no snoop
#CFLAGS= -Wall -Zsys -Zomf $(DBGFLAGS) $(DEFFLAGS) $(ADDINCS)

CC=gcc

#.SUFFIXES: .a .lib .o .obj .c

OBJ1=           AGLCRC.OBJ      ASYNC_OS.OBJ                        \
                BREC.OBJ        BSEND.OBJ       BTCONFIG.OBJ        \
                B_BANNER.OBJ    B_BBS.OBJ       B_FAXRCV.OBJ        \
                B_FLOFIL.OBJ    B_FRPROC.OBJ    B_FUSER.OBJ         \
                B_HELP.OBJ      B_INITVA.OBJ    B_LOGS.OBJ          \
                B_PASSWO.OBJ    B_PROTO.OBJ     B_RSPFIL.OBJ        \
                B_SBINIT.OBJ    B_SCRIPT.OBJ    B_SEARCH.OBJ        \
                B_SESSIO.OBJ    B_SPAWN.OBJ     B_TERM.OBJ          \
                B_TERMOV.OBJ    B_TODAY.OBJ     B_WAZOO.OBJ         \
                B_WHACK.OBJ     B_WZSEND.OBJ    CACHE.OBJ           \
                CHAT.OBJ        COMMON.OBJ      CSS.OBJ             \
                DATA.OBJ        DOSFUNCS.OBJ    DOWNLOAD.OBJ        \
                EMSI.OBJ        EVTPARSE.OBJ    FILE_DOS.OBJ        \
                FOSSIL.OBJ      FREEPOLL.OBJ    FTSC.OBJ            \
                HEAP.OBJ        HYDRA.OBJ       \
                JANUS.OBJ       KEYMAP.OBJ      LANGLOAD.OBJ        \
                M7REC.OBJ       M7SEND.OBJ      MAILER.OBJ          \
                MAILOVLY.OBJ    MAILROOT.OBJ    MDM_PROC.OBJ        \
                MISC.OBJ        NODEPROC.OBJ    OUTBOUND.OBJ        \
                PROMETER.OBJ        \
                RECVBARK.OBJ    RECVSYNC.OBJ    SBUF.OBJ            \
                SCHED.OBJ       SENDBARK.OBJ    SENDSYNC.OBJ        \
                SQUISH.OBJ      \
                SRIF.OBJ        STATETBL.OBJ        \
                TIMER.OBJ       UPLOAD.OBJ      VERSION.OBJ         \
                VERSION7.OBJ    VFOSSIL.OBJ     XMREC.OBJ           \
                XMSEND.OBJ      YOOHOO.OBJ      ZMISC.OBJ           \
                ZRECEIVE.OBJ    ZSEND.OBJ       MAXMCP.OBJ

OBJ2=           GET_LANG.OBJ    PUT_LANG.OBJ

INC1=           $(INCDIR)\bink.h        $(INCDIR)\com.h             \
                $(INCDIR)\com_os2.h     $(INCDIR)\externs.h         \
                $(INCDIR)\includes.h    $(INCDIR)\keybd.h           \
                $(INCDIR)\keyfncs.h     $(INCDIR)\prototyp.h        \
                $(INCDIR)\sbuf.h        $(INCDIR)\sched.h           \
                $(INCDIR)\squish.h      $(INCDIR)\xfer.h            \
                $(INCDIR)\zmodem.h      $(INCDIR)\prometer.h

default:        all

all:            binkley.lib bt32.exe patche

$(OBJ1):        $(SRCDIR)\$*.c  $(INC1)
    $(CC) $(CFLAGS) -c $(SRCDIR)\$*.c

$(OBJ2):        $(SRCDIR)\$*.c  $(INC1)
    $(CC) $(CFLAGS) -c $(SRCDIR)\$*.c

binkley.lib:    $(OBJ1)
    emxomfar  @binkley.rsp

bt32.exe:       $(SRCDIR)\bt.c  binkley.lib
    $(CC) $(CFLAGS) -o bt32.exe $(SRCDIR)\bt.c $(LNKFLAGS) $(ADDLIBS)

btutil32.exe:   $(SRCDIR)\btutil.c  binkley.lib
    $(CC) $(CFLAGS) -o btutil32.exe $(SRCDIR)\btutil.c $(LNKFLAGS) $(ADDLIBS)

#   generate language file from source

english.lng:    $(SRCDIR)\language.txt btutil32.exe
    btutil32 LNG key E $(SRCDIR)\language.txt english.lng

german.lng:     $(SRCDIR)\language.txt btutil32.exe
    btutil32 LNG key G $(SRCDIR)\language.txt german.lng

startrek.lng:   $(SRCDIR)\language.txt btutil32.exe
    btutil32 LNG key S $(SRCDIR)\language.txt startrek.lng

#   patch language file into bt32.exe

patche: bt32.exe btutil32.exe english.lng
    btutil32 LNG patch bt32.exe english.lng

patchg: bt32.exe btutil32.exe german.lng
    btutil32 LNG patch bt32.exe german.lng

patchs: bt32.exe btutil32.exe startrek.lng
    btutil32 LNG patch bt32.exe startrek.lng

clean:
    -del *.bak *.exe *.obj *.lib *.lng *.map *.zip *.lst *.err
    -del ..\src\*.bak ..\src\*.exe
    -del ..\include\*.bak
    -del *.a0? *.d0?
    -del ..\xe0*.* ..\patch.exe
    -del asa?????

pack:
    -zip -9 -r -u -g -o btsrcts \binksrc -x *.zip
    copy btsrcts.zip a:\

unpack:
    -unzip -o -u a:\btsrcts.zip -d /
