#############################################################################
#                                                                           #
# Make file for BinkleyTerm-OS/2 Version 2.60 XE                            #
#                                                                           #
# Compiler: VisualAge C++ 3.0 with CSD CTC305                               #
#                                                                           #
# This file is used to build the 32-bit version of the software for         #
# usage on OS/2 2.x, Warp v3 and Warp v4 systems.                           #
#                                                                           #
# Usage: nmake -f IBMVACPP.MAK ["CPU=<string>"] [optional target]           #
#                                                                           #
# If no target is specified, "all" will be generated.                       #
#                                                                           #
# Defining "CPU=<string>" (<string> may be `86', `186', `286', `386' and    #
# will result in a 386 32Bit-EXE to be built or '486' or '586' what will    #
# result in 486 or Pentium optimized EXEs to be built.) on the nmake        #
# command line will generate code optimized for the specified CPU type.     #
#                                                                           #
#############################################################################


SRC_DIR    = ..\src
INCL_DIR   = ..\include
LIB_DIR    = ..\lib

LINKLIBS    = OS2386.LIB
BINKLIBS    = $(LIB_DIR)\maxcomm.lib\
              $(LIB_DIR)\snserver.lib $(LIB_DIR)\mcp32.lib\
              $(LIB_DIR)\sesmgr.lib
              
!IF "$(CPU)" == "86"
coptf= /G3 /D_CPU=386
!ENDIF

!IF "$(CPU)" == "186"
coptf= /G3 /D_CPU=386
!ENDIF

!IF "$(CPU)" == "286"
coptf= /G3 /D_CPU=386
!ENDIF

!IF "$(CPU)" == "386"
coptf= /G3 /D_CPU=386
!ENDIF

!IF "$(CPU)" == "486"
coptf= /G4 /D_CPU=486
!ENDIF

!IF "$(CPU)" == "586"
coptf= /G5 /D_CPU=586
!ENDIF

# options to compile into Binkley
OPTFLAGS = /DNEED_SET_PRIOR /DOS_2 /DHYDRADEV /DPROMETER /DBTPE\
           /DOS2SETTITLE /DMAX_MCP /DSnoop
# /DNEED_OS2COMMS /DCSS
DEBFLAGS = /Ti /Tm
CFLAGS_N  = $(coptf) /O+ /W3 /Wuse /Wpar /Wdcl /Wcnv /Sm /Sp1 /Ss /C /Tl30 /Q $(OPTFLAGS) /I $(INCL_DIR)
CFLAGS_D  = $(DEBFLAGS) $(CFLAGS_N)
# /Ol    invoke intermediate code linker
# /Oinnn enable inline function code up to nnn intermediate code instr
# /W2    errors and warnings only, no infos
# /Sm    Ignore migration keywords (!?)
# /Sp1   pack aggregate members on alignment 1
# /Ss    allow // for comments in C-source
# /O+    optimize generated code
# /C     compile only
# /G5    Pentium optimization
# /Gs+   suppress stack probes in function prologues
# /Tl30  keep compiler 30 mins in memory
# /Ti    generate debugging information
# /Tm    debug memory management
# /Q     suppress the logo
# /DOS_2 #define OS_2
# /I     set include dir(s)

LFLAGS_N = /Q /B" /map /noi /nol /pmtype:vio /align:16 /base:65536 /stack:32768 /exepack"
LFLAGS_D = $(DEBFLAGS) $(LFLAGS_N)
# /Ti      include debug information
# /Fm      generate linker map file
# /B"..."  pass options to linker
# /Q       no logo
# /Ti      debug infos

# Generate Binkley without snoop (normal):
#     CFLAGS_N / LFLAGS_N for normal compile, CFLAGS_D / LFLAGS_D for debug,

CFLAGS   = $(CFLAGS_N)
LFLAGS   = $(LFLAGS_N)

CC       = ICC
LINK     = ICC

USEPCH = /Si
MAKEPCH = /Fi

DEF_H1   = $(INCL_DIR)\com.h $(INCL_DIR)\com_os2.h $(INCL_DIR)\xfer.h
DEF_H2   = $(INCL_DIR)\bink.h $(INCL_DIR)\zmodem.h $(INCL_DIR)\keybd.h
DEF_H3   = $(INCL_DIR)\sbuf.h $(INCL_DIR)\sched.h $(INCL_DIR)\externs.h
DEF_H4   = $(INCL_DIR)\includes.h $(INCL_DIR)\prototyp.h $(INCL_DIR)\keyfncs.h
DEF_H5   = $(INCL_DIR)\squish.h $(INCL_DIR)\debug.h 

DEF_H    = $(DEF_H1) $(DEF_H2) $(DEF_H3) $(DEF_H4) $(DEF_H5)

# use ASYNC_OS.OBJ below together with /DNEED_OS2COMMS above

cobj1=BT.OBJ       ASYNC.OBJ    FTSC.OBJ     B_SCRIPT.OBJ SBUF.OBJ
cobj2=BTCONFIG.OBJ BREC.OBJ     B_SEARCH.OBJ B_TODAY.OBJ
cobj3=B_TERMOV.OBJ BSEND.OBJ    B_SESSIO.OBJ B_FAXRCV.OBJ
cobj4=B_BANNER.OBJ B_SPAWN.OBJ  UPLOAD.OBJ   DOWNLOAD.OBJ
cobj5=B_BBS.OBJ    MAILER.OBJ   B_TERM.OBJ   CHAT.OBJ
cobj6=B_FLOFIL.OBJ MAILROOT.OBJ B_WAZOO.OBJ  MAILOVLY.OBJ SQUISH.OBJ
cobj7=B_FRPROC.OBJ MDM_PROC.OBJ B_WHACK.OBJ  SCHED.OBJ
cobj8=B_FUSER.OBJ  MISC.OBJ     B_WZSEND.OBJ TIMER.OBJ    CSS.OBJ
cobj9=B_HELP.OBJ   NODEPROC.OBJ SENDBARK.OBJ VFOSSIL.OBJ
cobja=B_INITVA.OBJ M7REC.OBJ    DATA.OBJ     M7SEND.OBJ   EMSI.OBJ
cobjb=B_PASSWO.OBJ YOOHOO.OBJ   VERSION7.OBJ MAXMCP.OBJ
cobjc=B_PROTO.OBJ  DOSFUNCS.OBJ ZMISC.OBJ    PROMETER.OBJ DEBUG.OBJ
cobjd=B_RSPFIL.OBJ EVTPARSE.OBJ ZRECEIVE.OBJ FREEPOLL.OBJ SRIF.OBJ
cobje=B_SBINIT.OBJ FOSSIL.OBJ   ZSEND.OBJ    VERSION.OBJ  HEAP.OBJ
cobjf=KEYMAP.OBJ   JANUS.OBJ    OUTBOUND.OBJ SENDSYNC.OBJ FILE_DOS.OBJ
cobjg=STATETBL.OBJ XMREC.OBJ    XMSEND.OBJ   LANGLOAD.OBJ CACHE.OBJ
cobjh=RECVBARK.OBJ RECVSYNC.OBJ HYDRA.OBJ    AGLCRC.OBJ   B_LOGS.OBJ

cobjs1=BTUTIL.OBJ  COMMON.OBJ

btobjs = $(cobj1) $(cobj2) $(cobj3) $(cobj4) $(cobj5) $(cobj6) $(cobj7) $(cobj8) $(cobj9) $(cobja) $(cobjb) $(cobjc) $(cobjd) $(cobje) $(cobjf) $(cobjg) $(cobjh)
btobjsc = $(btobjs) COMMON.OBJ

btpch = INCLUDES.OBJ

all: btutil32.exe bt32.exe english.lng startrek.lng deutsch.lng patcheng

clean :
        !del *.obj *.pch *.map *.exe *.lng

patcheng :
        btutil32 lng patch bt32.exe english.lng

patchstt :
        btutil32 lng patch bt32.exe startrek.lng

bt32.exe:  $(btpch) $(btobjsc)
        $(LINK) @<<
        $(LFLAGS)
        /FeBT32.EXE
        $(btobjsc)
        $(LINKLIBS)
        $(BINKLIBS)
<<

btutil32.exe: $(cobjs1)
        $(LINK) @<<
        $(LFLAGS)
        /FeBTUTIL32.EXE
        $(cobjs1)
        $(LINKLIBS)
<<

v7debug.exe: v7debug.obj
        $(LINK) @<<
        $(LFLAGS)
        /FeV7DEBUG.EXE
        v7debug.obj
<<        

english.lng: btutil32.exe $(SRC_DIR)\language.txt
 btutil32 lng key E $(SRC_DIR)\language.txt english.lng

startrek.lng: btutil32.exe $(SRC_DIR)\language.txt
 btutil32 lng key S $(SRC_DIR)\language.txt startrek.lng

deutsch.lng: btutil32.exe $(SRC_DIR)\language.txt
 btutil32 lng key G $(SRC_DIR)\language.txt deutsch.lng

$(btpch): $(SRC_DIR)\$*.c $(DEF_H)
        $(CC) $(CFLAGS) $(MAKEPCH) $(SRC_DIR)\$*.c

$(btobjs): $(SRC_DIR)\$*.c $(btpch)
        $(CC) $(CFLAGS) $(USEPCH) $(SRC_DIR)\$*.c

common.obj: $(SRC_DIR)\common.c $(DEF_H)
        $(CC) $(CFLAGS) $(SRC_DIR)\common.c

btutil.obj: $(SRC_DIR)\btutil.c $(DEF_H)
        $(CC) $(CFLAGS) $(SRC_DIR)\btutil.c

v7debug.obj: $(SRC_DIR)\v7debug.c $(DEF_H)
        $(CC) $(CFLAGS) $(SRC_DIR)\v7debug.c

