# makefile for compiling Binkley XE OS/2 with Watcom C/C++
# attention: there are some problems with v7nl stuff yet, maybe DLL calling
# convention. If someone has experience with watcom, please investigate on that

O1=async.obj ftsc.obj b_script.obj sbuf.obj btconfig.obj brec.obj
O2=b_search.obj b_today.obj b_termov.obj bsend.obj b_sessio.obj b_faxrcv.obj
O3=b_banner.obj b_spawn.obj upload.obj download.obj b_bbs.obj mailer.obj
O4=b_term.obj b_flofil.obj mailroot.obj b_wazoo.obj mailovly.obj squish.obj
O5=b_frproc.obj mdm_proc.obj b_whack.obj sched.obj b_fuser.obj misc.obj
O6=b_wzsend.obj timer.obj b_help.obj nodeproc.obj sendbark.obj vfossil.obj
O7=b_initva.obj m7rec.obj data.obj m7send.obj emsi.obj b_passwo.obj
O8=yoohoo.obj version7.obj b_proto.obj dosfuncs.obj zmisc.obj b_rspfil.obj
O9=evtparse.obj zreceive.obj b_sbinit.obj fossil.obj zsend.obj keymap.obj
O10=janus.obj outbound.obj sendsync.obj file_dos.obj statetbl.obj xmrec.obj
O11=xmsend.obj langload.obj recvbark.obj recvsync.obj hydra.obj aglcrc.obj
O12=b_logs.obj version.obj freepoll.obj srif.obj common.obj

BTOBJ=$O1 $O2 $O3 $O4 $O5 $O6 $O7 $O8 $O9 $O10 $O11 $O12

LNGOBJ=btlng.obj get_lang.obj put_lang.obj

CTLOBJ=btctl.obj common.obj

# OS/2
CC=wcl386

# DOS
# CC=wcl

SRC_DIR=..\src

# OS/2
GNAT=32

# DOS
# GNAT=

# OS/2
CFLAGS=-zq -w4 -c -z4 -DOS_2 -i=..\include

# DOS
# CFLAGS=-DMUST_FDOPEN -zq -ml -w4 -c -z4 -i=..\include 


# OS/2 & DOS
LFLAGS=-zq -k32768 -ml

all: btlng$(GNAT).exe english.lng startrek.lng bt$(GNAT).exe btctl$(GNAT).exe

clean:
        del *.obj
        del *.pch
        del *.lng
        del *.lib
        del *.bak
        del *.err
        del *.?0?

english.lng: btlng$(GNAT).exe $(SRC_DIR)\language.txt
        btlng$(GNAT) key E $(SRC_DIR)\language.txt english.lng

startrek.lng: btlng$(GNAT).exe $(SRC_DIR)\language.txt
        btlng$(GNAT) key S $(SRC_DIR)\language.txt startrek.lng

btctl$(GNAT).exe: $(CTLOBJ)
        $(CC) $(LFLAGS) -fe=btctl$(GNAT).exe $(CTLOBJ)

btlng$(GNAT).exe: $(LNGOBJ)
        $(CC) $(LFLAGS) -fe=btlng$(GNAT).exe $(LNGOBJ)

bt$(GNAT).exe: bt.obj $(BTOBJ) btlng$(GNAT).exe english.lng
        $(CC) $(LFLAGS) -fh=bt.pch -fe=bt$(GNAT).exe bt.obj bt.lib ..\lib\maxcomm.lib ..\lib\snserver.lib ..\lib\v7nl.lib
        btlng32 patch bt32.exe english.lng

bt.obj: $(SRC_DIR)\bt.c
        $(CC) $(CFLAGS) $(SRC_DIR)\bt.c

.c.obj:
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

async.obj: $(SRC_DIR)\async.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

ftsc.obj: $(SRC_DIR)\ftsc.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_script.obj: $(SRC_DIR)\b_script.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

sbuf.obj: $(SRC_DIR)\sbuf.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

btconfig.obj: $(SRC_DIR)\btconfig.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

brec.obj: $(SRC_DIR)\brec.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_search.obj: $(SRC_DIR)\b_search.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_today.obj: $(SRC_DIR)\b_today.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_termov.obj: $(SRC_DIR)\b_termov.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

bsend.obj: $(SRC_DIR)\bsend.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_sessio.obj: $(SRC_DIR)\b_sessio.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_faxrcv.obj: $(SRC_DIR)\b_faxrcv.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_banner.obj: $(SRC_DIR)\b_banner.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_spawn.obj: $(SRC_DIR)\b_spawn.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

upload.obj: $(SRC_DIR)\upload.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

download.obj: $(SRC_DIR)\download.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_bbs.obj: $(SRC_DIR)\b_bbs.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

mailer.obj: $(SRC_DIR)\mailer.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_term.obj: $(SRC_DIR)\b_term.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_flofil.obj: $(SRC_DIR)\b_flofil.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

mailroot.obj: $(SRC_DIR)\mailroot.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_wazoo.obj: $(SRC_DIR)\b_wazoo.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

mailovly.obj: $(SRC_DIR)\mailovly.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

squish.obj: $(SRC_DIR)\squish.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_frproc.obj: $(SRC_DIR)\b_frproc.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

mdm_proc.obj: $(SRC_DIR)\mdm_proc.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_whack.obj: $(SRC_DIR)\b_whack.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

sched.obj: $(SRC_DIR)\sched.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_fuser.obj: $(SRC_DIR)\b_fuser.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

misc.obj: $(SRC_DIR)\misc.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_wzsend.obj: $(SRC_DIR)\b_wzsend.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

timer.obj: $(SRC_DIR)\timer.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_help.obj: $(SRC_DIR)\b_help.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

nodeproc.obj: $(SRC_DIR)\nodeproc.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

sendbark.obj: $(SRC_DIR)\sendbark.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

vfossil.obj: $(SRC_DIR)\vfossil.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_initva.obj: $(SRC_DIR)\b_initva.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

m7rec.obj: $(SRC_DIR)\m7rec.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

data.obj: $(SRC_DIR)\data.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

m7send.obj: $(SRC_DIR)\m7send.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

emsi.obj: $(SRC_DIR)\emsi.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_passwo.obj: $(SRC_DIR)\b_passwo.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

yoohoo.obj: $(SRC_DIR)\yoohoo.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

version7.obj: $(SRC_DIR)\version7.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_proto.obj: $(SRC_DIR)\b_proto.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

dosfuncs.obj: $(SRC_DIR)\dosfuncs.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

zmisc.obj: $(SRC_DIR)\zmisc.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_rspfil.obj: $(SRC_DIR)\b_rspfil.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

evtparse.obj: $(SRC_DIR)\evtparse.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

zreceive.obj: $(SRC_DIR)\zreceive.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_sbinit.obj: $(SRC_DIR)\b_sbinit.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

fossil.obj: $(SRC_DIR)\fossil.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

zsend.obj: $(SRC_DIR)\zsend.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

keymap.obj: $(SRC_DIR)\keymap.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

janus.obj: $(SRC_DIR)\janus.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

outbound.obj: $(SRC_DIR)\outbound.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

sendsync.obj: $(SRC_DIR)\sendsync.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

file_dos.obj: $(SRC_DIR)\file_dos.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

statetbl.obj: $(SRC_DIR)\statetbl.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

xmrec.obj: $(SRC_DIR)\xmrec.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

xmsend.obj: $(SRC_DIR)\xmsend.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

langload.obj: $(SRC_DIR)\langload.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

recvbark.obj: $(SRC_DIR)\recvbark.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

recvsync.obj: $(SRC_DIR)\recvsync.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

hydra.obj: $(SRC_DIR)\hydra.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

aglcrc.obj: $(SRC_DIR)\aglcrc.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

b_logs.obj: $(SRC_DIR)\b_logs.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

version.obj: $(SRC_DIR)\version.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

freepoll.obj: $(SRC_DIR)\freepoll.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

srif.obj: $(SRC_DIR)\srif.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

common.obj: $(SRC_DIR)\common.c
        $(CC) $(CFLAGS) $<
        wlib -q bt -+$*.obj

btctl.obj: $(SRC_DIR)\btctl.c
        $(CC) $(CFLAGS) $<

btlng.obj: $(SRC_DIR)\btlng.c
        $(CC) $(CFLAGS) $<

get_lang.obj: $(SRC_DIR)\get_lang.c
        $(CC) $(CFLAGS) $<

put_lang.obj: $(SRC_DIR)\put_lang.c
        $(CC) $(CFLAGS) $<

