/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*              (C) Copyright 1987-96, Bit Bucket Software Co.              */
/*                                                                          */
/*            This module was originally written by Bob Hartman             */
/*                                                                          */
/*                  BinkleyTerm Initial Fullscreen Setup                    */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.260.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:42/1491                        */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*--------------------------------------------------------------------------*/

/* Include this file before any other includes or defines! */

#include "includes.h"

extern VIOMODEINFO vfos_mode;

static void readactivitydump(void);
static void writeactivitydump(void);

void 
b_sbinit (void)
{
    register int r;
    char junk[256];
    
    for (r = 0; r < 132; r++)
    {
        blanks[r * 2] = ' ';
        blanks[r * 2 + 1] = 7;
    }

    vfossil_init ();
    if (vfos_mode.col < 80)
        vfos_mode.col = 80;
    if (vfos_mode.row < 23)
        vfos_mode.row = 23;

    SB_ROWS = vfos_mode.row; /* TJW 960506 no "- 1" */
    SB_COLS = vfos_mode.col;

    SB_COLS_M_1 = SB_COLS - 1;

    /* TJW 960723 removed because unused ...
    SB_ROWS_M_1 = SB_ROWS - 1;
    SB_ROWS_M_2 = SB_ROWS - 2;
    */

    screen_clear ();
    sb_init ();

    wholewin = sb_new (0, 0, SB_ROWS, SB_COLS);
    sb_fill (wholewin,    ' ', colors.background);
    (void) sprintf (junk, MSG_TXT (M_NODE_COLON), TaskNumber, Full_Addr_Str (&my_addr));
    sb_move_puts (wholewin, 0, 0, junk);
    sb_move_puts (wholewin, 0, (short) (SB_COLS - (short) strlen (system_name)), system_name);
    bottom_line ();
    
    settingswin = sb_new_win (1, 0, TOP_PARTS_ROWS-1, 20,
                              ' ', colors.settings,
                              boxtype, colors.frames,
                              MSG_TXT (M_CURRENT_SETTINGS));
    sb_move_puts (settingswin, SET_EVNT_ROW, 0, MSG_TXT (M_EVENT_COLON));
    sb_move_puts (settingswin, SET_PORT_ROW, 0, MSG_TXT (M_PORT_COLON));
    sb_move_puts (settingswin, SET_STAT_ROW, 0, MSG_TXT (M_STATUS_INIT));

    historywin = sb_new_win (1, 20, TOP_PARTS_ROWS-1, 21,
                             ' ', colors.history,
                             boxtype, colors.frames,
                             MSG_TXT (M_TODAY_GLANCE));
    do_today (0);

    holdwin = sb_new_win (1, 41, TOP_PARTS_ROWS-1, (short) (SB_COLS - 41),
                          ' ', colors.hold,
                          boxtype, colors.frames,
                          MSG_TXT (M_PENDING_OUTBOUND));
    sb_move_puts (holdwin, 2, 6, MSG_TXT (M_INITIALIZING_SYSTEM));

    filewin = sb_new_win ((short) (SB_ROWS - BOTTOM_PARTS_ROWS), 0, BOTTOM_PARTS_ROWS-1, (short) SB_COLS,
                          ' ', colors.file,
                         boxtype, colors.frames,
                         MSG_TXT (M_TRANSFER_STATUS));

    callwin = sb_new_win (TOP_PARTS_ROWS, 0, (short) (SB_ROWS - TOP_PARTS_ROWS - BOTTOM_PARTS_ROWS), (short) SB_COLS,
                          ' ', colors.call,
                         boxtype, colors.frames,
                         MSG_TXT (M_RECENT_ACTIVITY));

    if (scrllines < callwin->lines) 
        scrllines = callwin->lines;

    callwin->linesize += 2; /* add one for \0 and 1 for padding */
    callwin->buffer    = calloc (scrllines*callwin->linesize,1);
    if(callwin->buffer==NULL) /* TJW 960606 are we running under DOS ? ;-) */
    {
        printf(MSG_TXT (M_MEM_ERROR));
        exit (2);
    }

    callwin->endbuff   = callwin->buffer + ((scrllines - 1) * callwin->linesize) ;
    callwin->lastline  = callwin->buffer ;
    callwin->lastshown = callwin->lastline ;

    readactivitydump();
}

void 
b_sbexit ()
{
    writeactivitydump();
}

#define DUMPMAGIC 0x19661220L

static void readactivitydump(void){
  char fname[PATHLEN];
  FILE *fp;
  int len;
  int saved_scrllines=0;
  short saved_linesize=0;
  long savedmagic;
  unsigned int savedlastline,savedlastshown;
  
  sb_fillc (callwin, ' ');

  sprintf(fname,"%s%s.A%02X", task_dir, PRDCT_PRFX, TaskNumber);

  if((fp=fopen(fname,read_binary))!=NULL){

    savedmagic=0L;
    fread(&savedmagic, sizeof(savedmagic), 1,fp);
    if(savedmagic!=DUMPMAGIC)
      goto end;

    fread(&saved_scrllines,sizeof(saved_scrllines),1,fp);
    if(saved_scrllines!=scrllines)
      goto end;

    fread(&saved_linesize, sizeof(saved_linesize), 1,fp);
    if(saved_linesize!=callwin->linesize)
      goto end;

    fread(&savedlastline,  sizeof(savedlastline),  1,fp);
    callwin->lastline=callwin->buffer+savedlastline;
    
    fread(&savedlastshown, sizeof(savedlastshown), 1,fp);
    callwin->lastshown=callwin->buffer+savedlastshown;

    len = scrllines * callwin->linesize;
    fread(callwin->buffer, len, 1, fp);

    savedmagic=0L;
    fread(&savedmagic, sizeof(savedmagic), 1,fp);
    if(savedmagic!=DUMPMAGIC)
      goto end;

    redraw_callwin();
          
end:
    fclose(fp);
  }
}

void redraw_callwin(void)
{
  char *p;
  short j;
  if (scrllines > callwin->lines) 
  {
     p = callwin->lastshown;
     sb_scrl (callwin, 0);

     /* jl 960729:  rewritten to avoid wrapping p below callwin->buffer
                    with segmented memory */
     for (j = callwin->lines-1; j >= 0; j--)
     {
        sb_move_puts (callwin, j, 0, p);
        if (p > callwin->buffer)
        {
           p -= callwin->linesize;
        }
        else
        {
           break;
        }
     }
  }
}

static void writeactivitydump(void){
  char fname[PATHLEN];
  FILE *fp;
  int len;
  unsigned int offset;
  long magic=DUMPMAGIC;
  
  sprintf(fname,"%s%s.A%02X", task_dir, PRDCT_PRFX, TaskNumber);

  if((fp=fopen(fname,write_binary))!=NULL){
    fwrite(&magic,              sizeof(magic),              1, fp);
    fwrite(&scrllines,          sizeof(scrllines),          1, fp);
    fwrite(&callwin->linesize,  sizeof(callwin->linesize),  1, fp);
    offset=callwin->lastline - callwin->buffer;
    fwrite(&offset,             sizeof(offset),             1, fp);
    offset=callwin->lastshown - callwin->buffer;
    fwrite(&offset,             sizeof(offset),             1, fp);
    len = scrllines * callwin->linesize;
    fwrite(callwin->buffer,     len,                        1, fp);
    fwrite(&magic,              sizeof(magic),              1, fp);
    fclose(fp);
  }
}
