/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*              (C) Copyright 1987-96, Bit Bucket Software Co.              */
/*                                                                          */
/*            This module was originally written by Bob Hartman             */
/*                                                                          */
/*                  BinkleyTerm Initial Fullscreen Setup                    */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.260.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:42/1491                        */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*--------------------------------------------------------------------------*/

/* Include this file before any other includes or defines! */

#include "includes.h"

void 
do_today (int show)
{
    char j[30], junk[256];
    ADDR tmp;

    if (un_attended && fullscreen)
    {
        (void) sprintf (j, "%d/%d/%d",
                        hist.mail_calls, hist.bbs_calls, hist.fax_calls);
        (void) sprintf (junk, MSG_TXT (M_BBS_MAIL), j);
        sb_move_puts (historywin, HIST_BBS_ROW, 0, junk);

        (void) sprintf (junk, MSG_TXT (M_CALLS_OUT), hist.calls_made);
        sb_move_puts (historywin, HIST_ATT_ROW, 0, junk);

        (void) sprintf (j, "%d/%ld", hist.connects, hist.callcost);
        (void) sprintf (junk, MSG_TXT (M_GOOD_COST), j);
        sb_move_puts (historywin, HIST_CONN_ROW, 0, junk);

        (void) sprintf (j, "%d/%d", hist.files_in, hist.files_out);
        (void) sprintf (junk, MSG_TXT (M_FILES_IO), j);
        sb_move_puts (historywin, HIST_FILE_ROW, 0, junk);

        sb_move_puts (historywin, HIST_LAST_ROW, 0, MSG_TXT (M_LAST));
    }
    tmp = hist.last_addr;
    tmp.Domain = NULL;
    last_type (hist.last_caller, &tmp);

    if (un_attended && fullscreen && show)
      sb_show();
}

void 
bottom_line ()
{
    if (fullscreen)
    {
        sb_move_puts (wholewin, (short) (SB_ROWS - 1), 0, ANNOUNCE);
        
        if (serial == -1)
            sb_puts (wholewin, MSG_TXT (M_UNREGISTERED));
        sb_move_puts (wholewin,
                     (short) (SB_ROWS - 1),
                     (short) (SB_COLS - strlen(MSG_TXT(M_ALTF10))),
                     MSG_TXT (M_ALTF10));
    }
}

void 
put_up_time ()
{
    if (fullscreen && (un_attended || doing_poll))
    {
        timedisplay();
        sb_show ();
    }
}

