/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*              (C) Copyright 1987-96, Bit Bucket Software Co.              */
/*                                                                          */
/*                                                                          */
/*                                                                          */
/*                BinkleyTerm WaZOO/EMSI Sendmail Processor                 */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.260.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:42/1491                        */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*--------------------------------------------------------------------------*/

/* Include this file before any other includes or defines! */

#include "includes.h"

#ifdef HAVE_HYDRA
#include "hydra.h"
#endif

extern int WaZOO_callback (char *);
extern int WaZOO_time (long);

void
ZedZapZip (int originator)
{
    int iFstat=0;
    
    /*--------------------------------------------------------------------*/
    /* ORIGINATOR: send/receive/send                                      */
    /*--------------------------------------------------------------------*/
    if (originator)
    {
        (void) send_WaZOO ();
        if (!CARRIER || no_pickup)
            return;
        if (!get_Zmodem (CURRENT.sc_Inbound, NULL))
            return;
        if (!CARRIER)
            return;
            
        if (SRIF_commandline[0]) /* mtt 960429 */
          iFstat = invoke_SRIF(0, WaZOO_callback, WaZOO_time);
        else
          iFstat = respond_to_file_requests (0, WaZOO_callback, WaZOO_time);
        if (iFstat)
            (void) Send_Zmodem (NULL, NULL, ((iFstat) ? END_BATCH : NOTHING_TO_DO), DO_WAZOO);
        mail_finished = 1;
    }

    /*--------------------------------------------------------------------*/
    /* CALLED SYSTEM: receive/send/receive                                */
    /*--------------------------------------------------------------------*/
    else
    {
        if (!get_Zmodem (CURRENT.sc_Inbound, NULL))
            return;
        if (!CARRIER)
            return;
        if (remote_pickup != 0)
            (void) send_WaZOO ();
        if (!CARRIER || !made_request)
            return;
        (void) get_Zmodem (CURRENT.sc_Inbound, NULL);
    }
}

/*--------------------------------------------------------------------------*/
/* WaZOO/EMSI                                                               */
/*--------------------------------------------------------------------------*/
void 
WaZOO (int originator)
{
    int i = 0, akas = 0;
    char j[200];
    char k[100];
    char fname[PATHLEN], fname2[PATHLEN];
    char *HoldName;
    ADDR saved_addr;
    ADDRP addrp;

    /*--------------------------------------------------------------------*/
    /* Initialize WaZOO/EMSI                                              */
    /*--------------------------------------------------------------------*/

    made_request = got_arcmail = got_packet = 0;

    Netmail_Session = 1;

    isOriginator = originator;

    if (originator &&
        ((remote_addr.Zone != called_addr.Zone) ||
        (remote_addr.Net != called_addr.Net)    ||
        (remote_addr.Node != called_addr.Node)  ||
        (remote_addr.Point != called_addr.Point)))
    {
        (void) sprintf (k, "%s", Full_Addr_Str (&remote_addr));
        (void) sprintf (j, MSG_TXT (M_CALLED), Full_Addr_Str (&called_addr), k);
        status_line (j);
    }
    else if (!originator)
        called_addr = remote_addr;

    if (remote_addr.Point == 0){
      strcpy(k, MSG_TXT(M_MCP_MAIL_XFER));
      sprintf(j, k, remote_addr.Zone, remote_addr.Net, remote_addr.Node);
    }else{
      strcpy(k, MSG_TXT(M_MCP_POINT_XFER));
      sprintf(j, k, remote_addr.Zone, remote_addr.Net,
                    remote_addr.Node, remote_addr.Point);
    }
    IPC_SetStatus(j);

    /* If we are using an external mail agent, call it now. */

    if (remote_pickup == -2)
    {
        num_rakas = akas = 1;
        status_line (">External Mail Session");
        remote_akas[0] = called_addr;
        (void) send_WaZOO ();
        goto end_WaZOO;
    }

    /* We need to have DCD here. */

    if (!CARRIER)
        return;

#ifdef  PROMETER
    prometer_init();    /*  TS 960701   */
#endif
#ifdef  CSS
    css_init();
#endif

    saved_addr = called_addr;
    switch (remote_pickup)
    {
    case -1:                    /* WaZOO Session */
        akas = 1;
        status_line (">WaZOO Session");
        remote_akas[0] = called_addr;
        break;

    case 0:                                /* TJW 960610 */
        status_line (">EMSI, no pickup");
        akas = 0;
        break;

    case 1:
        status_line (">EMSI, no pickup-all");
        if (num_rakas >= 1)
        {
            akas = 1;
            remote_akas[0] = called_addr;
        }
        break;

    case 2:
        status_line (">EMSI, pickup-all");
        akas = num_rakas;
        break;

    default:
        akas = 0;
        break;
    }

    /* Flag all AKA's received */

    for (i = 0; i < akas; i++)
    {
        status_line (">Setting flag_file for %s", Full_Addr_Str (&remote_akas[i]));
        if (flag_file (TEST_AND_SET, &remote_akas[i], 1))
        {                                             
            int n;

            status_line (">Failed to set flag_file for %s", Full_Addr_Str (&remote_akas[i]));

            /* Couldn't flag it, shift everything down one */

            akas--;
            for (n = i + 1; n <= akas; n++)
                remote_akas[n - 1] = remote_akas[n];

            /* Do this loop again since we just replaced this remote_aka */
            i--;

        }
    }

    if ((akas<=0)&&(remote_pickup!=0)) /* TJW 960610 fixes nopickup */
        goto end_WaZOO;

    num_rakas = akas;

    /* TJW 960721                                                  */
    /* remote_capability contains only ONE protocol we can also do */
    /* further, it is already checked if bidi protocols are ok     */
    
    /* Let's look into the BiDi protocols first */
        
#ifdef HAVE_HYDRA

    if ((unsigned) remote_capabilities & DOES_HYDRA)
    {
        status_line ("%s %sHydra", MSG_TXT (M_WAZOO_METHOD),
                                   do_RH1hydra ? "x" : "");
        hydra_init (hydra_options);
        (void) send_WaZOO();
        hydra_deinit();
    }
    else
#endif /* HAVE_HYDRA */

    if ((unsigned) remote_capabilities & DOES_IANUS)
    {
        status_line ("%s Janus", MSG_TXT (M_WAZOO_METHOD));
        Janus ();
    }
    else
    if (remote_capabilities & ZED_ZAPPER){
        status_line ("%s ZedZap", MSG_TXT (M_WAZOO_METHOD));
        ZedZapZip (originator);
    }
    else
    if (remote_capabilities & ZED_ZIPPER){
        status_line ("%s ZedZip", MSG_TXT (M_WAZOO_METHOD));
        ZedZapZip (originator);
    }
    else
    {
        if (remote_pickup == -1)
        {
            status_line ("%s DietIFNA", MSG_TXT (M_WAZOO_METHOD));
            if (originator)
                FTSC_sender (1);
            else
                (void) FTSC_receiver (1);
        }
    }

end_WaZOO:
    called_addr = saved_addr;

    for (i = 0; i < akas; i++)
    {
      addrp = &remote_akas[i];

      /* delete RQFs at end of session if session was successful */
      /* else rename to REQ to activate them again               */
      if(made_request){
        HoldName = HoldAreaNameMunge (addrp);
        (void) sprintf (fname, "%s%s.RQF", HoldName, Hex_Addr_Str (addrp));
        (void) sprintf (fname2, "%s%s.REQ", HoldName, Hex_Addr_Str (addrp));
        if(1)         /* !!! this should be a "session ok" flag !!! */
          (void) unlink (fname);        /* delete completed REQ now */
        else
          (void) rename(fname, fname2); /* reactivate incomplete REQ */
      }
      flag_file (CLEAR_FLAG, addrp, 1);
    }
                                                
    status_line (MSG_TXT (M_WAZOO_END));
#ifdef  PROMETER
    prometer_done();    /*  TS 960701   */
#endif
#ifdef  CSS
    css_done();
#endif
}                               /* WaZOO */

/*--------------------------------------------------------------------------*/
/* RESPOND TO FILE REQUEST                                                  */
/*--------------------------------------------------------------------------*/
int 
respond_to_file_requests (int f_sent,
    int (*callback) (char *), int (*calltime) (long))
{
    char req[PATHLEN];
    struct stat buf;
    int nfiles = 0;
    FILE *fp;
    int np;
    char *s;
    int fsent;
    ADDR foo;

    fsent = f_sent;             /* copy into local var  */
    /* this is for callback */
    if (!(matrix_mask & TAKE_REQ))
        goto done;

    for (np = 0; np <= ALIAS_CNT; np++)
    {
        foo = alias[np];

        if (foo.Net == 0)
            break;

        /* For a point, massage the address to get the right .REQ filename */

        if (foo.Point != 0)
        {
            foo.Node = foo.Point;
            foo.Point = 0;
            foo.Net = (pvtnet > 0) ? (word) pvtnet : 0;
        }

        (void) sprintf (req, request_template, CURRENT.sc_Inbound, Hex_Addr_Str (&foo), TaskNumber);

        if (!unix_stat (req, &buf))
        {
            if ((fp = fopen (req, read_ascii)) == NULL)
            {
                (void) got_error (MSG_TXT (M_OPEN_MSG), req);
                goto done;
            }

            while (!feof (fp))
            {
                req[0] = 0;
                if (fgets (req, 79, fp) == NULL)
                    break;

                /* ; as the first char is a comment */
                if (req[0] == ';')
                    continue;

                /* Get rid of the newline at the end */
                s = (char *) (req + strlen (req) - 1);
                while ((s >= req) && isspace (*s))
                    *s-- = '\0';

                if (req[0] == '\0')
                    continue;

                if ((nfiles = n_frproc (req, nfiles, callback, calltime)) < 0)
                    break;
            }

            (void) fclose (fp);

            (void) sprintf (req, request_template, CURRENT.sc_Inbound, Hex_Addr_Str (&foo), TaskNumber);
            (void) unlink (req);
            /* once we have satisfied a request, we can get out of here */
            break;
        }
    }

done:
    return fsent;
}
