/****************************************************************************/
/*  this module was written by tom schlangen                                */
/****************************************************************************/
#ifdef  CSS

/* Include this file before any other includes or defines! */
#include "includes.h"

/*

btee layout is something like this:

                    4         5         6         7         8
                ... 01234567890123456789012345678901234567890

                      + Current Session Statistics ---------+
                      |       Files   Size   CPS    Eff  Err|
                      |Sent       2   228      0     0%    0|
                      |Receivd    2   229K  8010   125%    0|
                      |Total      4   229K  6524   101%    0|
                      |Waiting    0     0 /    0       0 min|
                      +-------------------------------------+

latest proposed btxe layout with additional overlapped `today at a glance'
window:

2         3         4         5         6         7         8
0123456789012345678901234567890123456789012345678901234567890

 + Current Session Statistics ------------------------------+
 |<ftn adress>                                    <protocol>|
 |Tx current xxxc/yyyc zzz% hh:mm:ss xxxxx yyyy ABCDEFGH.IJK| <- filename
 |Tx total   xxxc/yyyc zzz% hh:mm:ss xxxxx yyyy Files  zzzzz| <- # files so far
 |Rx current xxxc/yyyc zzz% hh:mm:ss xxxxx yyyy ABCDEFGH.IJK| <- filename
 |Rx total   xxxc/yyyc zzz% hh:mm:ss xxxxx yyyy Files  zzzzz| <- # files so far
 +----------------------------------------------------------+
            ^         ^    ^        ^     ^    ^
            |pos./len.|%   |est.time| cps |err.|
            |         |done|        |     |cnt.|
            |         |so  |        |     |    |
            |         |far |        |     |    |

*/

/****************************************************************************/
/*  local constants                                                         */
/****************************************************************************/
#define CSS_ROW_TX_CUR 1               /*  row for tx current file     */
#define CSS_ROW_TX_TOT 2               /*  row for tx total            */
#define CSS_ROW_RX_CUR 3               /*  row for tx current file     */
#define CSS_ROW_RX_TOT 4               /*  row for rx total            */
#define CSS_MSG_X      0               /*  column of explanatory msgs  */

/****************************************************************************/
/*  local static data                                                       */
/****************************************************************************/
static REGIONP  csswin;
static BINK_SAVEP holdwinsave, historywinsave;

/****************************************************************************/
/*  functions                                                               */
/****************************************************************************/
void css_upd(void)
{
    if (un_attended && fullscreen)
    {
    }
}

void css_init(void)
{
    if (un_attended && fullscreen)
    {
        /*  save hold/history window contents                               */
        holdwinsave=sb_save (1, 41, TOP_PARTS_ROWS-1, (short) (SB_COLS - 41));
        historywinsave=sb_save (1, 20, TOP_PARTS_ROWS-1, 21);

        csswin = sb_new_win (1, 20, TOP_PARTS_ROWS-1, (short) (SB_COLS-20),
                              ' ', colors.hold,
                              boxtype, colors.frames,
                              MSG_TXT (M_CSS_CAPTION));

        sb_move (csswin, CSS_ROW_TX_CUR, CSS_MSG_X);
        sb_puts (csswin, MSG_TXT (M_CSS_TX_CUR));

        sb_move (csswin, CSS_ROW_TX_TOT, CSS_MSG_X);
        sb_puts (csswin, MSG_TXT (M_CSS_TX_TOT));

        sb_move (csswin, CSS_ROW_RX_CUR, CSS_MSG_X);
        sb_puts (csswin, MSG_TXT (M_CSS_RX_CUR));

        sb_move (csswin, CSS_ROW_RX_TOT, CSS_MSG_X);
        sb_puts (csswin, MSG_TXT (M_CSS_RX_TOT));
    }
}

void css_done(void)
{
    if (un_attended && fullscreen)
    {
        /*  restore old holdwin contents    */
        sb_restore(holdwinsave);
        sb_restore(historywinsave);
        csswin=NULL;
    }
}

#endif  /*  #ifdef CSS */
