#include <malloc.h>
#include "includes.h"

#ifdef __WATCOMC__

static long heapmax = 0;

void heapchk(void)
{
    struct _heapinfo hi;
    long usedblocks = 0;
    long freeblocks = 0;
    long usedbytes  = 0;
    long freebytes  = 0;
    long heapnow;
    int chk;

    hi._pentry = NULL;
    while ( _heapwalk(&hi) == _HEAPOK ) {
        switch(hi._useflag) {
            case _USEDENTRY:
                usedbytes += hi._size;
                usedblocks++;
                break;
            case _FREEENTRY:
                freebytes += hi._size;
                freeblocks++;
                break;
        }
    }

    heapnow = (usedbytes+freebytes) + (usedblocks+freeblocks)*sizeof(hi);
    if ( heapnow>heapmax ) {
        status_line(":Heap: Used:%ld/%ld, Free:%ld/%ld, Size:%ld",
            usedbytes, usedblocks,
            freebytes, freeblocks,
            heapnow);
        heapmax=heapnow;
    }

    chk = _heapchk();
    if (chk!=_HEAPOK)
        status_line("!Heap: _heapchk() returns %d (not _HEAPOK)");
}

#else  /* __WATCOMC__ */ 

void heapchk(void)
{}

#endif /* __WATCOMC__ */
