/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*              (C) Copyright 1987-96, Bit Bucket Software Co.              */
/*                                                                          */
/*    This module has significant work from Vince Perriello, Bob Hartman,   */
/*             Holger Schurig, Michael Buenter and Doug Boone               */
/*                  BinkleyTerm Outbound Area Manipulation                  */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.260.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:42/1491                        */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*--------------------------------------------------------------------------*/

/* Include this file before any other includes or defines! */

#include "includes.h"

extern char *mail_status_chars (unsigned int);

/* local prototypes */

static int mail_change (BINK_SAVEP, int);
static int mail_delreq (BINK_SAVEP, int);
static int mail_stop (BINK_SAVEP, int);
static int mail_addr (BINK_SAVEP, int);

static void LOCALFUNC zoom_window (REGIONP, MAILP, MAILP);
static int LOCALFUNC mail_addsend (ADDRP, char *, char *);
static int LOCALFUNC mail_addrequest (ADDRP, char *, char *, char *);
static int LOCALFUNC kill_node (char *);
static void LOCALFUNC call_tries (ADDRP baddr, int *calls, int *badcalls);
static int LOCALFUNC get_NodeAdr(char *);

/* local variables */
static int curl;
static MAILP cur, oldp, oldcur;

#define ZHELPSIZE 9

int
Do_Zoom (BINK_SAVEP rp, int x)
{
    REGIONP zoomwin;
    MAILP p;
    long t_idle;
    int i, c;
    int changed = 0;
    short z;

    x = 1;

    /* is there a window */

    if (rp == NULL)
        return (0);

    zoomwin = rp->region;

    /* draw a box */

    sb_fill (zoomwin, ' ', colors.hold);
    sb_box (zoomwin, boxtype, colors.frames);

    /* give it a title */

    sb_caption (zoomwin, MSG_TXT (M_ZOOM_TITLE));

    /* clear the inside of zoomed outbound */

    zoomwin->sr0++;
    zoomwin->sr1--;
    zoomwin->sc0++;
    zoomwin->sc1--;
    sb_fillc (zoomwin, ' ');
    zoomwin->sr0--;
    zoomwin->sr1++;
    zoomwin->sc0--;
    zoomwin->sc1++;

    /* Put the help text at the bottom of the window */

    c = (int) (zoomwin->sr1 - 1);
    i = M_ZOOM_HELP;

    for (z = zoomwin->sr1 - ZHELPSIZE + 1; z < (short) c; i++, z++)
    {
        sb_move_puts (zoomwin, z, 1, MSG_TXT (i));
    }

    /* is there a rescan flag? */
    if (forcerescancheck ())
    {
        sb_move_puts (zoomwin, 1, 2, MSG_TXT (M_ZOOM_WAIT));
        sb_show ();
        xmit_reset (0, 0);
    }

  /* RDH *** Changes begin */
  show_alive();
  /* RDH *** Changes end */

    /* is there something in the outbound? */

    if (mail_top == NULL)
    {
        sb_move_puts (zoomwin, 10, 10, MSG_TXT (M_NOTHING_IN_OUTBOUND));
        sb_show ();
        wait_for_key (120);
        return (x);
    }

    p = cur = mail_top;
    oldp = oldcur = NULL;
    curl = 2;
    zoom_window (zoomwin, p, cur);

    t_idle = timerset (6000);
    while (!timeup (t_idle) && (PEEKBYTE () == (short) 0xffff))
    {
        if (KEYPRESS ())
        {
            t_idle = timerset (3000);

            c = (int) KbRemap (FOSSIL_CHAR ());

            switch ((unsigned) c)
            {
            case F_PEND_PGUP:
                for (i = 2; i < (zoomwin->sr1 - ZHELPSIZE); i++)
                {
                    if (p->prev != NULL)
                        p = p->prev;
                    if (cur->prev != NULL)
                        cur = cur->prev;
                }
                break;

            case F_PEND_PGDN:
                for (i = 2; i < (zoomwin->sr1 - ZHELPSIZE); i++)
                {
                    if (p->next != NULL)
                        p = p->next;
                    if (cur->next != NULL)
                        cur = cur->next;
                }
                break;

            case F_PEND_UPAR:
                if (curl > 2)
                {
                    cur = cur->prev;
                }
                else
                {
                    if (p->prev != NULL)
                        p = cur = p->prev;
                }
                break;

            case F_PEND_DNAR:
                if (curl < (zoomwin->sr1 - 1 - ZHELPSIZE))
                {
                    if (cur->next != NULL)
                        cur = cur->next;
                }
                else
                {
                    if (p->next != NULL)
                        p = p->next;
                    if (cur->next != NULL)
                        cur = cur->next;
                }
                break;

            case F_PEND_HOME:
                p = cur = mail_top;
                break;

            case F_PEND_END:
                while (p->next != NULL)
                {
                    p = p->next;
                }
                cur = p;
                for (i = 2; i < (zoomwin->sr1 - 1 - ZHELPSIZE); i++)
                {
                    if (p->prev != NULL)
                        p = p->prev;
                }
                break;

            case F_ZOOM_ADDRESS:    /* readdress */
                changed = sb_popup (10, 5, 4, 70, mail_addr, 0);
                break;

            case F_UN_CALLRIGHTNOW:
            case F_ZOOM_CRASH:  /* crash */
                changed = sb_popup (10, 5, 4, 70, mail_change, (int) 'C');
                break;

            case F_ZOOM_DIRECT:/* direct */
                changed = sb_popup (10, 5, 4, 70, mail_change, (int) 'D');
                break;

            case F_UN_GETFILE:
                changed = sb_popup (10, 5, 9, 70, Do_Get, 0); /* RDH *** 26.May.1996 (2 Lines more please ) */
                break;

            case F_ZOOM_GET:    /* get files */
                changed = sb_popup (10, 5, 9, 70, Do_Get, 1); /* RDH *** 26.May.1996 (2 Lines more please ) */
                break;

            case F_ZOOM_HOLD:   /* hold */
                changed = sb_popup (10, 5, 4, 70, mail_change, (int) 'H');
                break;

            case F_ZOOM_KILLTRIES:  /* reset dial tries */
                changed = sb_popup (10, 5, 4, 70, mail_stop, 0);
                break;

            case F_ZOOM_NORMAL:/* normal */
                changed = sb_popup (10, 5, 4, 70, mail_change, (int) 'N');
                break;

            case F_UN_POLLPKT:
                changed = sb_popup (10, 5, 4, 70, Do_Poll_Packet, 0);
                break;

            case F_ZOOM_POLL:   /* poll */
                changed = sb_popup (10, 5, 5, 70, Do_Poll_Packet, 1);
                break;

            case F_ZOOM_KILLREQ:    /* delete request */
                changed = sb_popup (10, 5, 4, 70, mail_delreq, 0);
                break;

            case F_UN_SENDFILE:
                changed = sb_popup (10, 5, 6, 70, Do_Send, 0);
                break;

            case F_ZOOM_SEND:   /* send files */
                changed = sb_popup (10, 5, 6, 70, Do_Send, 1);
                break;

            case F_ZOOM_STOPMAIL:   /* stop mail */
                changed = sb_popup (10, 5, 4, 70, mail_stop, 1);
                break;

            case F_ZOOM_KILLNODE:
            case F_UN_KILLNODESMAIL:
                changed = !sb_popup (10, 5, 4, 70, Do_Kill, 1);
                break;

            default:            /* Space, ESCape or Return terminates */
                c &= 0x00ff;
                if ((c == 0x20) || (c == 0x1b) || (c == 0x0d))
                    return (x);
                break;
            }

            if (changed != 0)
            {
                sb_move (zoomwin, (short) curl, 1);
                sb_wa (zoomwin, colors.hold, 78);
                sb_move_puts (zoomwin, 1, 2, MSG_TXT (M_ZOOM_WAIT));
                sb_show ();
                xmit_reset (0, 1);
                t_idle = timerset (6000);
                x = 1;
                /* is there something in the outbound ? */
                if (mail_top == NULL)
                {
                    sb_move_puts (zoomwin, 10, 10, MSG_TXT (M_NOTHING_IN_OUTBOUND));
                    sb_show ();
                    wait_for_key (120);
                    return (x);
                }
                else
                {
                    oldp = oldcur = NULL;
                    p = cur = mail_top;
                    curl = 2;
                    changed = 0;
                }
            }

            if ((oldp != p) || (oldcur != cur))
                zoom_window (zoomwin, p, cur);

        }
        time_release ();
    }
    return (x);
}

static void LOCALFUNC
zoom_window (REGIONP zoomwin, MAILP p, MAILP cur)
{
    int i;
    int calls, badcalls;
    int zsize = (zoomwin->sr1) - ZHELPSIZE;

    char out_str[100]; /* TJW 960427 increased size */

    if (oldp == p)
    {
        oldcur = cur;
        sb_move (zoomwin, (short) curl, 1);
        sb_wa (zoomwin, colors.hold, 78);
        i = 2;
        while ((i < zsize) && (p != cur))
        {
            i++;
            p = p->next;
        }
        sb_move (zoomwin, (short) i, 1);
        sb_wa (zoomwin, colors.calling, 78);
        curl = i;
        sb_show ();
        return;
    }

    /* save old status */

    oldp = p;
    oldcur = cur;

    /* give it a header */

    sb_move_puts (zoomwin, 1, 1, MSG_TXT (M_ZOOM_HEADER));

    sb_move (zoomwin, (short) curl, 1);
    sb_wa (zoomwin, colors.hold, 78);

    for (i = 2; i < zsize; i++)
    {
        long age;

        if (p == NULL)
            break;

        sb_move (zoomwin, (short) i, 1);

        if (p == cur)
        {
            sb_wa (zoomwin, colors.calling, 78);
            curl = i;
        }

        call_tries (&(p->mail_addr), &calls, &badcalls);

        age = (unix_time (NULL) - p->oldest) / 86400L;

        /* TJW 960427 minor optimizations */
        sprintf (out_str, " %-34s%4u %9lu %3lu %5d %5d %5s%c ",
            Full_Addr_Str (&(p->mail_addr)),
            p->numfiles, p->mailsize, age, calls, badcalls,
            mail_status_chars (p->mailtypes),
            mail_stat (p));

        sb_puts (zoomwin, out_str);
        p = p->next;
    }

    /* clear the rest of the zoomed outbound */
    if (i <= zsize)
    {
        zoomwin->sr0 += i;
        zoomwin->sr1 -= ZHELPSIZE;
        zoomwin->sc0++;
        zoomwin->sc1--;
        sb_fillc (zoomwin, ' ');
        zoomwin->sr0 -= i;
        zoomwin->sr1 += ZHELPSIZE;
        zoomwin->sc0--;
        zoomwin->sc1++;
    }

    sb_show ();
}

static int
mail_change (BINK_SAVEP p, int x)
{
    REGIONP r;
    char iname[PATHLEN], oname[PATHLEN], tname[PATHLEN];
    char *HoldName, *result, *temp_buffer, junk[256];
    struct FILEINFO fileinfo;
    int ihandle, ohandle;
    int check;
    int written = 1;
    int buff_size;
    int change = 0;

    if (p == NULL)
        return (change);

    r = p->region;

    sb_fill (r, ' ', colors.popup);
    sb_box (r, boxtype, colors.popup);

    switch ((char) x)
    {
    case 'C':
        {
            strcpy (oname, "Crash");
            break;
        }
    case 'D':
        {
            strcpy (oname, "Direct");
            break;
        }
    case 'H':
        {
            strcpy (oname, "Hold");
            break;
        }
    case 'N':
        {
            strcpy (oname, "Normal");
            x = (int) 'F';
            break;
        }
    }

    sprintf (junk, MSG_TXT (M_ZOOM_CHANGE),
        Full_Addr_Str (&(cur->mail_addr)), oname);

    sb_move_puts (r, 0, 1, junk);

    sb_move_puts (r, 1, 2, MSG_TXT (M_ARE_YOU_SURE));
    (void) sb_input_chars (r, 1, 22, junk, 1);

    /* If user says 'no', get out */

    if (junk[0] != (char) toupper (MSG_TXT (M_YES)[0]))
        return (change);

    if (flag_file (TEST_AND_SET, &(cur->mail_addr), 0))
    {
        sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
        wait_for_key (60);
        return (0);
    }

    /* first append/rename ?LO */

    HoldName = HoldAreaNameMunge (&(cur->mail_addr));
    (void) sprintf (tname, "%s%s.?LO", HoldName,
        Hex_Addr_Str (&(cur->mail_addr)));
    (void) sprintf (oname, "%s%s.%cLO", HoldName,
        Hex_Addr_Str (&(cur->mail_addr)), (char) x);

    if (!dfind (&fileinfo, tname, 0))
    {
        do
        {
            buff_size = (int) fileinfo.size;
            strcpy (iname, fileinfo.name);
            result = strchr (iname, '.');
            result++;
            if (*result != (char) x)
            {
                if (cur->mail_addr.Point != 0)
                {
                    (void) sprintf (iname, "%s%04x%04x.PNT\\%s",
                        HoldName, cur->mail_addr.Net,
                        cur->mail_addr.Node, fileinfo.name);
                }
                else
                {
                    (void) sprintf (iname, "%s%s", HoldName, fileinfo.name);
                }
                if (rename (iname, oname) != 0)
                {
                    temp_buffer = (char *) malloc (buff_size + 1);
                    ihandle = open (iname, O_RDONLY | O_BINARY);
                    ohandle = open (oname, O_APPEND | O_BINARY | O_WRONLY);
                    sprintf (junk, MSG_TXT (M_ZOOM_APPEND), MSG_TXT (M_ZOOM_MAIL_ATT));
                    sb_move_puts (r, 2, 2, junk);
                    do
                    {
                        check = read (ihandle, temp_buffer, buff_size);
                        if (check)
                            written = write (ohandle, temp_buffer, check);
                    }
                    while (check > 0);
                    close (ihandle);
                    close (ohandle);
                    if (written > 0)
                        unlink (iname);
                    free (temp_buffer);
                }
                else
                {
                    sprintf (junk, MSG_TXT (M_ZOOM_RENAME), MSG_TXT (M_ZOOM_MAIL_ATT));
                    sb_move_puts (r, 2, 2, junk);
                }
                change = 1;
            }
        }
        while (!dfind (&fileinfo, NULL, 1));
        (void) (dfind (&fileinfo, NULL, 2));
    }

    /* now rename ?UT */

    if ((char) x == 'F')
        x = (int) 'O';
    (void) sprintf (tname, "%s%s.?UT", HoldName,
        Hex_Addr_Str (&(cur->mail_addr)));
    (void) sprintf (oname, "%s%s.%cUT", HoldName,
        Hex_Addr_Str (&(cur->mail_addr)), (char) x);
    if (!dfind (&fileinfo, tname, 0))
    {
        do
        {
            buff_size = (int) fileinfo.size;
            strcpy (iname, fileinfo.name);
            result = strchr (iname, '.');
            result++;
            if (*result != (char) x)
            {
                if (cur->mail_addr.Point != 0)
                {
                    (void) sprintf (iname, "%s%04x%04x.PNT\\%s",
                        HoldName, cur->mail_addr.Net,
                        cur->mail_addr.Node, fileinfo.name);
                }
                else
                {
                    (void) sprintf (iname, "%s%s", HoldName, fileinfo.name);
                }
                if ((rename (iname, oname)) != 0)
                {
                    if (buff_size > 60)
                        append_pkt (r, buff_size, iname, oname);
                }               /* do append if rename failed */
                else
                {
                    sprintf (junk, MSG_TXT (M_ZOOM_RENAME), MSG_TXT (M_ZOOM_MAIL_PKT));
                    sb_move_puts (r, 2, 2, junk);
                }
                change = 1;
            }
        }
        while (!dfind (&fileinfo, NULL, 1));
        (void) (dfind (&fileinfo, NULL, 2));
    }                           /* end of ?UT handling */

    (void) flag_file (CLEAR_FLAG, &(cur->mail_addr), 0);
    wait_for_key (60);
    return (change);
}

void
append_pkt (REGIONP r, unsigned int size, char *iname, char *oname)
{
    int ihandle, ohandle;
    struct tm *dt;
    time_t now;
    struct _pkthdr *header;
    char *copy, junk[256];
    unsigned int buff_size, go;

    if(r){
      sprintf (junk, MSG_TXT (M_ZOOM_APPEND), MSG_TXT (M_ZOOM_MAIL_PKT));
      sb_move_puts (r, 2, 2, junk);
    }

    header = (struct _pkthdr *) malloc (sizeof (struct _pkthdr) + 1);

    ohandle = open (oname, O_BINARY | O_RDWR);
    ihandle = open (iname, O_BINARY | O_RDONLY);

    go = read (ohandle, header, sizeof (struct _pkthdr));

    lseek (ohandle, 0L, SEEK_SET);

    /* Update the packet header to reflect that its been messed with */

    unix_time (&now);
    dt = unix_localtime (&now);

    header->year = dt->tm_year + 1900;
    header->month = dt->tm_mon + 1;
    header->day = dt->tm_mday;
    header->hour = dt->tm_hour;
    header->minute = dt->tm_min;
    header->second = dt->tm_sec;
    header->product = PRDCT_CODE;

    go = write (ohandle, header, sizeof (struct _pkthdr));

    free (header);

    lseek (ohandle, -2L, SEEK_END);
    lseek (ihandle, ((long) sizeof (struct _pkthdr)), SEEK_SET);
    size -= sizeof (struct _pkthdr);

    buff_size = size;
    if ((copy = (char *) malloc (buff_size)) == NULL)
    {
        do
        {
            buff_size = (buff_size / 10) * 9;
            copy = (char *) malloc (buff_size);
        }
        while (copy == NULL);
    }
    do
    {
        go = read (ihandle, copy, buff_size);
        go = write (ohandle, copy, go);
        size -= buff_size;
        if (buff_size > size)
            buff_size = size;
    }
    while (size > 0);
    free (copy);
    close (ihandle);
    close (ohandle);
    if (go > 0)
        unlink (iname);
    else
    {
        sprintf (junk, MSG_TXT (M_ZOOM_ERRAPP), MSG_TXT (M_ZOOM_MAIL_PKT));
        if(r)
           sb_move_puts (r, 2, 2, junk);
        else
           status_line(junk);
    }
}

static int
mail_stop (BINK_SAVEP p, int x)
{
    REGIONP r;
    int change = 0;
    char stop[PATHLEN];
    char *HoldName;
    char sure[2];
    FILE *fp;
    struct FILEINFO fileinfo;

    if (p == NULL)
        return (change);

    r = p->region;

    sb_fill (r, ' ', colors.popup);
    sb_box (r, boxtype, colors.popup);

    if (x)
        sprintf (stop, MSG_TXT (M_ZOOM_STOP),
            Full_Addr_Str (&(cur->mail_addr)));
    else
        sprintf (stop, MSG_TXT (M_ZOOM_DELETE),
            Full_Addr_Str (&(cur->mail_addr)));

    sb_move_puts (r, 0, 1, stop);

    sb_move_puts (r, 1, 2, MSG_TXT (M_ARE_YOU_SURE));
    (void) sb_input_chars (r, 1, 22, sure, 1);

    /* If user says 'no', get out */

    if (sure[0] != (char) toupper (MSG_TXT (M_YES)[0]))
        return (change);

    if (flag_file (TEST_AND_SET, &(cur->mail_addr), 0))
    {
        sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
        wait_for_key (60);
        return (0);
    }

    HoldName = HoldAreaNameMunge (&(cur->mail_addr));
    (void) sprintf (stop, "%s%s.$$?", HoldName,
        Hex_Addr_Str (&(cur->mail_addr)));

    if (!dfind (&fileinfo, stop, 0))
    {
        do
        {
            if (cur->mail_addr.Point != 0)
            {
                (void) sprintf (stop, "%s%04x%04x.PNT\\%s",
                    HoldName, cur->mail_addr.Net,
                    cur->mail_addr.Node, fileinfo.name);
            }
            else
            {
                (void) sprintf (stop, "%s%s", HoldName, fileinfo.name);
            }

            unlink (stop);
        }
        while (!dfind (&fileinfo, NULL, 1));
        (void) (dfind (&fileinfo, NULL, 2));
        sb_move_puts (r, 2, 2, MSG_TXT (M_ZOOM_DELCOUNT));
        change = 1;
    }

    if (x)
    {
        (void) sprintf (stop, "%s%s.$$9", HoldName,
            Hex_Addr_Str (&(cur->mail_addr)));
        sb_move_puts (r, 2, 2, MSG_TXT (M_ZOOM_NOSEND));
        fp = share_fopen (stop, append_ascii, DENY_WRITE);
        if (fp == (FILE *) NULL)
        {
            sb_move_puts (r, 2, 2, MSG_TXT (M_ZOOM_ERRNOSEND));
        }
        else{
            change = 1;
            fclose (fp);
        }
    }
    (void) flag_file (CLEAR_FLAG, &(cur->mail_addr), 0);
    wait_for_key (60);
    return (change);
}

static int
mail_delreq (BINK_SAVEP p, int x)
{
    REGIONP r;
    int rhandle;
    char req[PATHLEN];
    char sure[2], junk[256];
    char *HoldName;

    if (p == NULL)
        return (0);

    r = p->region;
    x = 0;

    sb_fill (r, ' ', colors.popup);
    sb_box (r, boxtype, colors.popup);

    sprintf (junk, MSG_TXT (M_ZOOM_DELREQ),
        Full_Addr_Str (&(cur->mail_addr)));

    sb_move_puts (r, 0, 1, junk);

    sb_move_puts (r, 1, 2, MSG_TXT (M_ARE_YOU_SURE));
    (void) sb_input_chars (r, 1, 22, sure, 1);

    /* If user says 'no', get out */

    if (sure[0] != (char) toupper (MSG_TXT (M_YES)[0]))
        return (x);

    if (flag_file (TEST_AND_SET, &(cur->mail_addr), 0))
    {
        sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
        wait_for_key (60);
        return (0);
    }

    HoldName = HoldAreaNameMunge (&(cur->mail_addr));
    (void) sprintf (req, "%s%s.REQ", HoldName,
        Hex_Addr_Str (&(cur->mail_addr)));

    if (dexists (req))
    {
        rhandle = open (req, O_RDONLY | O_BINARY);
        if (rhandle == -1)
        {
            sb_move_puts (r, 2, 2, MSG_TXT (M_ZOOM_ERRREQ));
        }
        else
        {
            close (rhandle);
            unlink (req);
            sb_move_puts (r, 2, 2, MSG_TXT (M_ZOOM_DEL_REQ));
            x = 1;
        }
        wait_for_key (60);
    }
    (void) flag_file (CLEAR_FLAG, &(cur->mail_addr), 0);
    return (x);
}

static void LOCALFUNC
append_fil (REGIONP r, unsigned int size, char *iname, char *oname, char *desc)
{
    char *temp_buffer;
    char temp[50];
    int ihandle, ohandle;
    int check;
    int written = 1;

    temp_buffer = (char *) malloc (size + 1);
    ihandle = open (iname, O_RDONLY | O_BINARY);
    ohandle = open (oname, O_APPEND | O_BINARY | O_WRONLY);
    (void) sprintf (temp, MSG_TXT (M_ZOOM_APPEND), desc);
    sb_move_puts (r, 2, 2, temp);
    do
    {
        check = read (ihandle, temp_buffer, size);
        if (check)
            written = write (ohandle, temp_buffer, check);
    }
    while (check > 0);
    close (ihandle);
    close (ohandle);
    if (written > 0)
        unlink (iname);
    free (temp_buffer);
}

static int LOCALFUNC
appren_mail (REGIONP r, ADDRP fromaddr, ADDRP toaddr, char *ftype, char *desc)
{
    char iname[PATHLEN], oname[PATHLEN], tname[PATHLEN];
    char *HoldName;
    struct FILEINFO fileinfo;
    int buff_size;
    int change = 0;

    HoldName = HoldAreaNameMunge (fromaddr);
    (void) sprintf (tname, "%s%s.%s", HoldName, Hex_Addr_Str (fromaddr), ftype);
    if (!dfind (&fileinfo, tname, 0))
    {
        do
        {
            buff_size = (int) fileinfo.size;
            HoldName = HoldAreaNameMunge (toaddr);
            (void) sprintf (oname, "%s%s.%s", HoldName, Hex_Addr_Str (toaddr),
                &(fileinfo.name[9]));
            HoldName = HoldAreaNameMunge (fromaddr);
            if (cur->mail_addr.Point != 0)
            {
                (void) sprintf (iname, "%s%04x%04x.PNT\\%s", HoldName,
                    fromaddr->Net, fromaddr->Node, fileinfo.name);
            }
            else
            {
                (void) sprintf (iname, "%s%s", HoldName, fileinfo.name);
            }
            if (rename (iname, oname) != 0)
            {
                if (!strcmp (desc, "?UT"))  /* mail packet */
                {
                    if (buff_size > 60)
                        append_pkt (r, buff_size, iname, oname);
                }
                else
                    /* other file */
                {
                    append_fil (r, buff_size, iname, oname, desc);
                }
            }
            else
            {
                sprintf (iname, MSG_TXT (M_ZOOM_RENAME), desc);
                sb_move_puts (r, 2, 2, iname);
            }
            change = 1;
        }
        while (!dfind (&fileinfo, NULL, 1));
        (void) (dfind (&fileinfo, NULL, 2));
    }
    return (change);
}

static int
mail_addr (BINK_SAVEP p, int x)
{
    REGIONP r;
    char iname[PATHLEN], sure[2];
    ADDR addr;

    x = 0;

    if (p == NULL)
        return (0);

    r = p->region;

    sb_fill (r, ' ', colors.popup);
    sb_box (r, boxtype, colors.popup);

    sb_move_puts (r, 0, 1, MSG_TXT (M_ZOOM_DESTINATION));

    sb_move_puts (r, 1, 2, MSG_TXT (M_ZOOM_NEWADDR));
    if (!sb_input_chars (r, 1, 18, iname, 36))
    {
        if (!find_address (iname, &addr))
        {
            return (0);
        }
        if (nodefind (&addr, 0))
        {
            sprintf (iname, "Node: %-18.18s - %-20.20s",
                Full_Addr_Str (&addr), newnodedes.SystemName);
            sb_move_puts (r, 1, 2, iname);
        }
        sb_move_puts (r, 2, 2, MSG_TXT (M_ARE_YOU_SURE));
        (void) sb_input_chars (r, 2, 22, sure, 1);

        /* If user says 'no', get out */

        if (sure[0] != (char) toupper (MSG_TXT (M_YES)[0]))
            return (x);

        if (flag_file (TEST_AND_SET, &(cur->mail_addr), 0))
        {
            sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
            wait_for_key (60);
            return (0);
        }
        if (flag_file (TEST_AND_SET, &addr, 0))
        {
            (void) flag_file (CLEAR_FLAG, &(cur->mail_addr), 0);
            sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
            wait_for_key (60);
            return (0);
        }

        /* first append/rename ?LO */

        appren_mail (r, &(cur->mail_addr), &addr, "?LO", "mail attaches");

        /* append/rename REQ */

        appren_mail (r, &(cur->mail_addr), &addr, "REQ", "request files");

        /* now rename ?UT */

        appren_mail (r, &(cur->mail_addr), &addr, "?UT", "mail packets ");

        (void) flag_file (CLEAR_FLAG, &addr, 0);
        (void) flag_file (CLEAR_FLAG, &(cur->mail_addr), 0);
        wait_for_key (60);
        x = 1;
    }                           /* end of address input */
    return (x);
}

int
Do_Get (BINK_SAVEP p, int x)
{
    REGIONP r;
    char SystemName[128];   /* RDH *** 26.May.1996 hold the output string */
    char node[51];
    char file[51];
    char fileparam[20];
    char flavor[2];
    char yesno[2];
    char more[2];
    int busy = 0;
    int did_it = 0;
    short i = 0;
    ADDR addr;
    char junk[256];
    
    if (p == NULL)
        return (0);

    r = p->region;

    if (x)
    {
        addr = cur->mail_addr;

        /* Busy the node if we can. */

        if (flag_file (TEST_AND_SET, &addr, 0))
        {
            sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
            wait_for_key (60);
            return (-1);
        }
        busy = 1;
    }

    /* First fill it all with blanks */

    sb_fill (r, ' ', colors.popup);

    /* Now draw the box */

    sb_box (r, boxtype, colors.popup);
    sb_move_puts (r, 0, 1, MSG_TXT (M_GET_FILE));

    /* Now do the fields */

    for (;;)
    {
        sb_move_puts (r, 1, 2, MSG_TXT (M_ADDRESS_TO_GET_FROM));

        /* Display address if zoomed, ask for it if not. */

        if (x)
        {
            strncpy (node, Full_Addr_Str (&addr), 46);
            node[35] = '\0';
            sb_move_puts (r, 1, 23, node);
        }
        else
        {
reinputnode1:
            if (sb_input_chars (r, 1, 23, node, 46))
                break;
            if (version7)
                if (get_NodeAdr(node))
                {
                    sb_move_puts (r, 1, 23+strlen(node)+1, MSG_TXT(M_NODE_NOT_FOUND));
                    wait_for_key(60);
                    goto reinputnode1;
                }
            if (!find_address (node, &addr))
            {
                if (!did_it)
                    did_it = -1;
                break;
            }

            /* RDH *** changes begin */
            if (!nodefind (&addr,(int) 0))
            {
                sb_move_puts (r, 1, 23+strlen(node)+1, MSG_TXT(M_NODE_NOT_FOUND));
                sprintf(junk, MSG_TXT(M_SHOULD_I_USE), Full_Addr_Str(&addr));
                sb_move_puts (r, 2, 2, junk);
                (void) sb_input_chars (r, 2, 2+strlen(junk)+1 , yesno, 1);
                if ( (char) toupper(yesno[0]) == MSG_TXT(M_YES)[0] )
                {
                    sb_move_puts (r, 1, 22, "                                              ");
                    sb_move_puts (r, 2, 1, "                                                                  ");
                    sb_move_puts (r, 1, 23, Full_Addr_Str(&addr));
                    x = 1;
                }
                else
                {
                    sb_move_puts (r, 2, 1, "                                                                  ");
                    goto reinputnode1;
                } /* endif */
            }
            else
            {
                /* show systemName */
                sb_move_puts (r, 1, 22, "                                              ");
                sprintf(SystemName,"%s, %s",Full_Addr_Str (&addr),newnodedes.SystemName);
                SystemName[47] = '\0';
                sb_move_puts (r, 1, 23, SystemName);
                x = 1;
            }
            /* RDH *** changes end */

            /* Busy the node if we can. */

            if (flag_file (TEST_AND_SET, &addr, 0))
            {
                sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
                wait_for_key (60);
                if (!did_it)
                    did_it = -1;
                break;
            }
            busy = 1;
        }

        /* Ask for the filename and password/size */
        sb_move_puts (r, 3, 2, MSG_TXT (M_GETFILE_ANDPWD));

        /* Get the filename */
        if (sb_input_chars (r, 4+i, 2, file, 12))
            break;

        /* Get the password/size if any */
        (void) sb_input_chars (r, 4+i, 18, fileparam, 18);
        (void) sb_input_chars (r, 4+i, 37, flavor, 1);

        /* Get the file if we can */

        if (flavor[0] != 'Q')
        {
            if (mail_addrequest (&addr, file, fileparam, flavor) == 0)
                did_it = 1;
            else if (!did_it)
                did_it = -1;
        }

        /* Unbusy the node */

        if (!x)
        {
            (void) flag_file (CLEAR_FLAG, &addr, 0);
            busy = 0;
        }

        /* Anything more to do? */

        if (i<2)
        {
          i++;
        }
        else
        {
            i = 0;
            sb_move_puts (r, 7, 2, MSG_TXT (M_GET_MORE));
            (void) sb_input_chars (r, 7, 36, more, 1);
            if (more[0] == (char) toupper ('o'))
            {
                more[0] = (char) toupper (MSG_TXT (M_YES)[0]);
                x = 0;
            }
            if (more[0] != (char) toupper (MSG_TXT (M_YES)[0]))
                break;
            /* Yes, clear the box. */
            sb_fill (r, ' ', colors.popup);
            /* Now draw the box */
            sb_box (r, boxtype, colors.popup);
            sb_move_puts (r, 0, 1, MSG_TXT (M_GET_FILE));
        } /* endif */
        /* RDH *** changes end */
    }

    /* If we busied something, get rid of it. */
    if (busy)
        (void) flag_file (CLEAR_FLAG, &addr, 0);
    return (did_it);
}

static int LOCALFUNC
mail_addrequest (ADDRP pAddr, char *file, char *fileparam, char *flavor)
{
    char *HoldName;
    char fname[PATHLEN];
    FILE *fp;

    if (flavor[0] == '\0')
        flavor[0] = 'N';
    if ((flavor[0] != 'C') && (flavor[0] != 'H') && (flavor[0] != 'N') &&
        (flavor[0] != 'D'))
        return (-3);
    if (flavor[0] == 'N')
        flavor[0] = 'F';
    flavor[1] = '\0';

    HoldName = HoldAreaNameMunge (pAddr);

    /* Now see if we should send anything back to him */

    (void) sprintf (fname, "%s%s.REQ", HoldName, Hex_Addr_Str (pAddr));
    if ((fp = fopen (fname, append_binary)) == NULL)
        return (-2);

    (void) fprintf (fp, "%s", file);
    if (fileparam[0] != '\0')
    {
        (void) fprintf (fp, " %s", fileparam);
    }
    (void) fprintf (fp, "\r\n");
    (void) fclose (fp);

    (void) mail_addsend (pAddr, "", flavor);
    return (0);
}

int
Do_Poll_Packet (BINK_SAVEP p, int x)
{
    REGIONP r;
    char node[51];
    char more[2];
    int busy = 0;
    int did_it = 0;
    ADDR addr;

    if (p == NULL)
        return (0);

    r = p->region;

    if (x)
    {
        addr = cur->mail_addr;

        /* Busy the node if we can. */

        if (flag_file (TEST_AND_SET, &addr, 0))
        {
            sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
            wait_for_key (60);
            return (-1);
        }
        busy = 1;
    }

    /* First fill it all with blanks */

    sb_fill (r, ' ', colors.popup);

    /* Now draw the box */

    sb_box (r, boxtype, colors.popup);
    sb_move_puts (r, 0, 1, MSG_TXT (M_ZOOM_POLL));

    /* Now do the fields */

    sb_move_puts (r, 1, 2, MSG_TXT (M_POLL_WHOM));

    /* Display address if zoomed, ask for it if not. */

    if (x)
    {
        strncpy (node, Full_Addr_Str (&addr), 39);
        node[39] = '\0';
        sb_move_puts (r, 1, 14, node);
    }
    else
    {
reinputnode4:
        if (sb_input_chars (r, 1, 14, node, 40))
            goto Done;

        if (version7)
            if (get_NodeAdr(node))
                goto reinputnode4;

        if (!find_address (node, &addr))
        {
            if (!did_it)
                did_it = -1;
            goto Done;
        }

        /* Busy the node if we can. */

        if (flag_file (TEST_AND_SET, &addr, 0))
        {
            sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
            wait_for_key (60);
            if (!did_it)
                did_it = -1;
            goto Done;
        }
        busy = 1;
    }

    if (x)
    {
        sb_move_puts (r, 2, 2, MSG_TXT (M_ARE_YOU_SURE));
        if (sb_input_chars (r, 2, 22, more, 1))
            goto Done;
        if (more[0] != (char) toupper (MSG_TXT (M_YES)[0]))
            goto Done;
    }

    if (mail_addsend (&addr, "", "C") == 0)
        did_it = 1;
    else if (!did_it)
        did_it = -1;
Done:

    /* If we busied something, get rid of it. */

    if (busy)
        (void) flag_file (CLEAR_FLAG, &addr, 0);
    return (did_it);
}

int
Do_Send (BINK_SAVEP p, int x)
{
    REGIONP r;
    char node[51];
    char file[51];
    char flavor[2];
    char yesno[2];
    char SystemName[128];                /* RDH *** 26.May.96 */
    char more[2];
    int busy = 0;
    int did_it = 0;
    short i;
    ADDR addr;
    char junk[256];
  /* RDH *** changes begin */
  struct FILEINFO fileinfo;
  int rc;
  /* RDH *** changes end */

    if (p == NULL)
        return (0);

    r = p->region;

    if (x)
    {
        addr = cur->mail_addr;

        /* Busy the node if we can. */

        if (flag_file (TEST_AND_SET, &addr, 0))
        {
            sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
            wait_for_key (60);
            return (-1);
        }
        busy = 1;
    }

    /* First fill it all with blanks */

    sb_fill (r, ' ', colors.popup);

    /* Now draw the box */
    sb_box (r, boxtype, colors.popup);
    sb_move_puts (r, 0, 1, MSG_TXT (M_SEND_FILE));

    /* Now do the fields */

    for (;;)
    {
        sb_move_puts (r, 1, 2, MSG_TXT (M_ADDRESS_TO_SEND_TO));

        /* Display address if zoomed, ask for it if not. */

        if (x)
        {
            strncpy (node, Full_Addr_Str (&addr), 46);
            node[46] = '\0';
            sb_move_puts (r, 1, 22, node);
        }
        else
        {
reinputnode2:
            if (sb_input_chars (r, 1, 22, node, 47))
                break;

            if (version7)
                if (get_NodeAdr(node))
                {  
                    sb_move_puts (r, 1, 22+strlen(node)+1, MSG_TXT(M_NODE_NOT_FOUND));
                    wait_for_key(60);
                    goto reinputnode2;
                }

            if (!find_address (node, &addr))
            {
                if (!did_it)
                    did_it = -1;
                break;
            }

            if (!nodefind (&addr,(int) 0))
            {

                sb_move_puts (r, 1, 22+strlen(node)+1, MSG_TXT(M_NODE_NOT_FOUND));
                sprintf(junk, MSG_TXT(M_SHOULD_I_USE), Full_Addr_Str(&addr));
                sb_move_puts (r, 2, 2, junk);
                (void) sb_input_chars (r, 2, 2+strlen(junk)+1 , yesno, 1);
                if ( (char) toupper(yesno[0]) == MSG_TXT(M_YES)[0] )
                {
                    sb_move_puts (r, 1, 22, "                                              ");
                    sb_move_puts (r, 2, 1, "                                                                  ");
                    sb_move_puts (r, 1, 23, Full_Addr_Str(&addr));
                    x = 1;
                }
                else
                {
                    sb_move_puts (r, 2, 1, "                                                                  ");
                    goto reinputnode2;
                } /* endif */
            }
            else
            {
                /* show systemName */
                sb_move_puts (r, 1, 22, "                                              ");
                sprintf(SystemName,"%s, %s",Full_Addr_Str (&addr),newnodedes.SystemName);
                SystemName[47] = '\0';
                sb_move_puts (r, 1, 23, SystemName);
                x = 1;
            }
            /* RDH *** changes end */


            /* Busy the node if we can. */

            if (flag_file (TEST_AND_SET, &addr, 0))
            {
                sb_move_puts (r, 2, 2, MSG_TXT (M_NODE_BUSY));
                wait_for_key (60);
                if (!did_it)
                    did_it = -1;
                break;
            }
            busy = 1;
        }

        /* Ask for the filename */
        /* RDH *** changes begin */
        rc = 1;
        while(rc)
        {
            sb_move_puts (r, 2, 2, MSG_TXT (M_FILE_TO_SEND));
            if (sb_input_fname (r, 2, 22, file, 47)) /* RDH *** 26-Apr-96 */
                break;
            rc = dfind (&fileinfo, file, 0);
            if(!rc)        /* File Found */
            {
                int ii = strlen(file);
                while(ii && (file[ii] != '\\') && (file[ii] != ':'))
                  ii--;
                file[ii+1] = '\0';
                strcat(file,fileinfo.name);
            }
            sb_move_puts (r, 2, 22, file);
        }
        /* RDH *** changes end */

        /* Get the flavor or quit */

        sb_move_puts (r, 3, 2, MSG_TXT (M_SEND_FLAVOR));
        (void) sb_input_chars (r, 3, 49, flavor, 1);

        /* Send the file if we can */

        if (flavor[0] != 'Q')
        {
            if (mail_addsend (&addr, file, flavor) == 0)
                did_it = 1;
            else if (!did_it)
                did_it = -1;
        }

        /* Unbusy the node */

        if (!x)
        {
            (void) flag_file (CLEAR_FLAG, &addr, 0);
            busy = 0;
        }

        /* Anything more to do? */

        sb_move_puts (r, 4, 2, MSG_TXT (M_SEND_MORE));
    /* RDH *** changes begin */
    (void) sb_input_chars (r, 4, 33, more, 1);
    if (more[0] == (char) toupper ('o'))
    {
      more[0] = (char) toupper (MSG_TXT (M_YES)[0]);
      x = 0;
    }
        if (more[0] != (char) toupper (MSG_TXT (M_YES)[0]))
            break;
    /* RDH *** changes end */

        /* Yes, clear the box. */
        for (i = 1; i <= 4; i++)
        {
            sb_move_puts (r, i, 2, "                                                 ");
        }
    }

    /* If we busied something, get rid of it. */

    if (busy)
        (void) flag_file (CLEAR_FLAG, &addr, 0);
    return (did_it);
}

static int LOCALFUNC
mail_addsend (ADDRP pAddr, char *file, char *flavor)
{
    char *HoldName;
    char fname[PATHLEN];
    FILE *fp;

    if (flavor[0] == '\0')
        flavor[0] = 'N';
    if ((flavor[0] != 'C') && (flavor[0] != 'H') && (flavor[0] != 'N') &&
        (flavor[0] != 'D'))
        return (-3);
    if (flavor[0] == 'N')
        flavor[0] = 'F';
    flavor[1] = '\0';
    HoldName = HoldAreaNameMunge (pAddr);
    (void) sprintf (fname, "%s%s.%sLO", HoldName,
        Hex_Addr_Str (pAddr), flavor);
    if ((fp = fopen (fname, append_binary)) == NULL)
    {
        return (-2);
    }
    else
    {
        if (file[0] != '\0')
            (void) fprintf (fp, "%s\r\n", file);
        (void) fclose (fp);
    }
    return (0);
}

int
Do_Kill (BINK_SAVEP p, int x)
{
    REGIONP r;
    char node[51];
    char sure[2];

    if (p != NULL)
    {
        r = p->region;

        /* First fill it all with blanks */
        sb_fill (r, ' ', colors.popup);

        /* Now draw the box */
        sb_box (r, boxtype, colors.popup);

        sb_move_puts (r, 0, 1, MSG_TXT (M_KILL_MAIL));

        /* Now do the fields */
        sb_move_puts (r, 1, 2, MSG_TXT (M_ADDRESS_TO_KILL));

        if (x)
        {
            strncpy (node, Full_Addr_Str (&cur->mail_addr), 50);
            node[50] = '\0';
            sb_move_puts (r, 1, 19, node);
        }
        else if (sb_input_chars (r, 1, 19, node, 50))
            return 0;

        sb_move_puts (r, 2, 2, MSG_TXT (M_KILL_ALL_MAIL));
        sb_puts (r, MSG_TXT (M_ARE_YOU_SURE));
        (void) sb_input_chars (r, 2, 38, sure, 1);
        if (sure[0] == (char) toupper (MSG_TXT (M_YES)[0]))
            x = kill_node (node);
        else x = 0;
    }
    else x = 0;

    /* Return value is never checked, just use x so lint and -W3 don't get mad */

    return (x);
}

int
Do_Poll (BINK_SAVEP p, int x)
{
    char node[51];
    REGIONP r;

    happy_compiler = x;         /* Makes the compiler happy! */
    if (p != NULL)
    {
        r = p->region;

        /* First fill it all with blanks */

        sb_fill (r, ' ', colors.popup);

        /* Now draw the box */

        sb_box (r, boxtype, colors.popup);
        sb_move_puts (r, 0, 1, MSG_TXT (M_NODE_TO_POLL));

        /* Now do the fields */

        sb_move_puts (r, 1, 2, MSG_TXT (M_POLL_WHOM));

reinputnode3:
        if (sb_input_chars (r, 1, 14, node, 40))
          return(FALSE);

            if (version7)
                if (get_NodeAdr(node))
                    goto reinputnode3;

        return (find_address (node, &next_addr));
    }
    return (FALSE);
}

static int LOCALFUNC
kill_node (char *node)
{
    ADDR addr;
    char *HoldName;
    char *p;
    char fname[PATHLEN];
    struct FILEINFO fileinfo = { { 0 } };
    int j;

    if (find_address (node, &addr))
    {
        if (flag_file (TEST_AND_SET, &addr, 0))
        {
            return (-1);
        }

        HoldName = HoldAreaNameMunge (&addr);

        (void) sprintf (fname, "%s%s.*", HoldName, Hex_Addr_Str (&addr));
        j = 0;
        while (!dfind (&fileinfo, fname, j))
        {
            j = 1;

            /* Don't delete the .bsy flags yet */

            if ((p = strchr (fileinfo.name, '.')) != NULL)
            {
                if (strcmp (p, ".BSY") == 0)
                    continue;
            }

            if (addr.Point != 0)
            {
                (void) sprintf (fname, "%s%04hx%04hx.PNT\\%s",
                    HoldName, addr.Net, addr.Node, fileinfo.name);
            }
            else
                (void) sprintf (fname, "%s%s", HoldName, fileinfo.name);

            (void) unlink (fname);
        }
        if (j)
            (void) dfind (&fileinfo, NULL, 2);

        (void) flag_file (CLEAR_FLAG, &addr, 0);
        return (0);
    }
    /* else */
    return (-1);
}

static void LOCALFUNC
call_tries (ADDRP baddr, int *calls, int *badcalls)
{
    int res;
    int i, j;
    struct FILEINFO bad_dta = { { 0 } };
    char *HoldName;

    char fname[PATHLEN];

    HoldName = HoldAreaNameMunge (baddr);
    (void) sprintf (fname, "%s%s.$$?", HoldName, Hex_Addr_Str (baddr));
    j = (int) strlen (fname) - 1;           /* Point at ?          */
    res = -1;                               /* Initialize to fail  */

    i = 0;                                  /* This says findfirst */
    while (!dfind (&bad_dta, fname, i))     /* as long as we match */
    {
        if (isdigit (bad_dta.name[11]))     /* is there a digit?   */
        {
            fname[j] = bad_dta.name[11];    /* Yes, copy to fname  */
            res = fname[j] - '0';           /* Save it for testing */
            break;                          /* Get out of while    */
        }
        else
            i = 1;                          /* Else use findnext   */
    }
    if (i)
        (void) dfind (&bad_dta, NULL, 2);

    /* Initialize the return values */

    *calls = *badcalls = 0;

    /* Is it automatically ok (no .$$ file there) ? */

    if (res == -1)
        return;

    /* We now have the number of bad calls (calls with carrier) */

    *badcalls = res;

    /* Open the file and find out how many total calls were made */

    i = open (fname, O_RDONLY | O_BINARY);
    if (i != -1)
    {
        res = 0;
        (void) read (i, (char *) &res, sizeof (int));
        (void) close (i);
    }

    *calls = res;
    return;
}

#if 0
static char LOCALFUNC xlat_flavor (char flavor);
static char LOCALFUNC
xlat_flavor (char flavor)
{
    char *real_flavor = "CHDN";
    char *user_flavor;

    user_flavor = MSG_TXT (M_CHDN_FLAGS);
    for (;;)
    {
        if (!*real_flavor)
            break;
        if (*user_flavor == flavor)
        {
            return *real_flavor;
        }
        user_flavor++;
        real_flavor++;
    }
    return (0);
}
#endif

typedef struct SEntry
  {
      char   Name[28];
      char   Nodestr[24];
      char   Flgstr[20];
      struct SEntry *Priv;
      struct SEntry *Next;
  } SENTRY, *pSENTRY;


void lookupbox(REGIONP r)
{
    /* First fill it all with blanks */
    sb_fill (r, ' ', colors.popup);
    /* Now draw the box */
    sb_box (r, boxtype, colors.popup);
    sb_move_puts (r, 0, 1, MSG_TXT (M_SELECTANODE));
    sb_move_puts (r, 1, 1, MSG_TXT (M_LOOKUPTITLE));
}

void dispentry(REGIONP r, SENTRY *pActEntry, int line)
{
    sb_move_puts (r, line, 1, pActEntry->Name);
    sb_move_puts (r, line, 25, pActEntry->Nodestr);
    sb_move_puts (r, line, 46, pActEntry->Flgstr);
}

/* RDH *** changes 22.Jun.96 */
/* first lookup functions for lookup after enter a sysopname */
/* only available under OS/2 */
int LOCALFUNC get_NodeAdr(char *in)
{
    BINK_SAVEP p;                     /* pointer to save scrren   */
    REGIONP    r;                     /* regionpointer            */
    V7RCB      V7rcb;                 /* request block            */
    V7NODE     V7node;                /* V7 format node record    */
    int        V7rc;                  /* return code              */
    SENTRY     SelEntry;
    SENTRY     *pActEntry;            /* pointer to actuell Entry */
    SENTRY     *pTmpEntry;            /* Pointer to Main Entry    */

    char       pszSysOpIndex[PATHLEN];
    char       pszNodeDat[PATHLEN];
    char       *tmpptr;
    int        c;
    int        i,count;
    int        row,entry,ret;
    long       t_idle;

    row = entry = ret = 0;
    memset(&SelEntry, '\0', sizeof(SENTRY));
    SelEntry.Priv       = NULL;
    SelEntry.Next       = NULL;
    pActEntry  = &SelEntry;

    tmpptr = skip_blanks (in);
    if (!isdigit (*tmpptr) && (*tmpptr != '.'))              /* Sysopname used */
    {
        (void) strcpy (pszNodeDat, net_info);                /* take nodelist path */
        (void) strcat (pszNodeDat, nodelist_base);           /* add in the filename*/
        (void) strcat (pszNodeDat, ".DAT");                  /* then the extension */
        (void) strcpy (pszSysOpIndex, net_info);             /* take nodelist path */
        (void) strcat (pszSysOpIndex, "SYSOP");              /* add in the filename*/
        (void) strcat (pszSysOpIndex, ".NDX");               /* then the extension */

        V7Initialize();
        memset(&V7rcb, '\0', sizeof(V7RCB));
        V7rcb.pszSysOpIndex = pszSysOpIndex;
        V7rcb.pszDataName   = pszNodeDat;
        V7rcb.pV7Node       = &V7node;
        memset(&V7node, '\0', sizeof(V7NODE));
        strcpy(V7node.SysopName, in);
        V7rc = V7FindFirstSysOp(&V7rcb);
        if (V7rc)
        {
          return(1);
        }
        count=0;
        while (!V7rc)
        {
            count++;
            strcpy(pActEntry->Name,V7node.SysopName);
            sprintf(pActEntry->Nodestr,"%2d:%d/%d.%d",V7node.ZoneNumber,
                                       V7node.NetNumber, V7node.NodeNumber,
                                       (V7node.NodeFlags & B_point) ? V7node.HubNode : 0);
            sprintf(pActEntry->Flgstr,"%4s  %5d  %3d  %c",(V7node.NodeFlags & B_CM) ? "CM" : "  ",
                                      V7node.BaudRate,
                                      V7node.ModemType,
                                      (V7node.Password[0]!='\0') ? '+' : ' ');

            pActEntry->Next = malloc(sizeof(SENTRY));
            pTmpEntry = pActEntry;
            pActEntry=pActEntry->Next;
            memset(pActEntry, '\0', sizeof(SENTRY));
            pActEntry->Priv = pTmpEntry;
            V7rc = V7FindNext(&V7rcb);
        } /* endwhile */
        V7FindClose(&V7rcb);
        V7Finish();

        p = sb_save(5,5,15,70);
        if (p != NULL)
        {
            r = p->region;
            lookupbox(r);

            /* Now draw the entrys first time */
            i = 0;
            pActEntry = &SelEntry;
            while ( (pActEntry->Next != NULL) && (i < 12))
            {
                dispentry(r, pActEntry, 2+i);
                i++; pActEntry = pActEntry->Next;
            } /* endwhile */

            /* select the first entry */
            sb_move(r,2+row,1);
            sb_wa(r,colors.hold,68);
            sb_show();

            t_idle = timerset (6000);
            while (!timeup (t_idle) && (PEEKBYTE () == (short) 0xffff))
            {
                if (KEYPRESS ())
                {
                    t_idle = timerset (3000);
                    c = (int) KbRemap (FOSSIL_CHAR ());
                    switch ((unsigned) c)
                    {
                      case F_PEND_UPAR:
                        if (row)
                        {
                          sb_move(r,2+row,1);
                          sb_wa(r,colors.popup,68);
                          row--;
                        }
                        else
                        {
                          if (entry)
                          {
                            entry--;
                            pActEntry = &SelEntry;
                            for (i=0; i<entry; i++)
                              pActEntry = pActEntry->Next;
                            i=0;
                            lookupbox(r);
                            while ( (pActEntry->Next != NULL) && (i < 12))
                            {
                              dispentry(r, pActEntry, 2+i);
                              i++; pActEntry = pActEntry->Next;
                            } /* endwhile */
                          } /* endif */
                        } /* endif */
                      break;
                      case F_PEND_DNAR:
                        if ( (row<11) && (row<count-1) )
                        {
                          sb_move(r,2+row,1);
                          sb_wa(r,colors.popup,68);
                          row++;
                        }
                        else
                        {
                          entry++;
                          pActEntry = &SelEntry;
                          for (i=0; i<entry; i++)
                            pActEntry = pActEntry->Next;
                          i=0;
                          lookupbox(r);
                          while ( (pActEntry->Next != NULL) && (i < 12))
                          {
                            dispentry(r, pActEntry, 2+i);
                            i++; pActEntry = pActEntry->Next;
                          } /* endwhile */
                          if (i<12)
                          {
                            entry--;
                            pActEntry = &SelEntry;
                            for (i=0; i<entry; i++)
                              pActEntry = pActEntry->Next;
                            i=0;
                            lookupbox(r);
                            while ( (pActEntry->Next != NULL) && (i < 12))
                            {
                              dispentry(r, pActEntry, 2+i);
                              i++; pActEntry = pActEntry->Next;
                            } /* endwhile */
                          } /* endif */
                        } /* endif */
                      break;
                      default:
                        c &= 0x00ff;
                       if (c == 0x0d)
                         goto endselect;
                       if (c == 0x1b)
                       {
                         ret = 1;
                         goto endselect;
                       }
                      break;
                    }
                    sb_move(r,2+row,1);
                    sb_wa(r,colors.hold,68);
                    sb_show();
                }
                time_release ();
                show_alive();
            }
endselect:
            pActEntry = &SelEntry;
            for (i=0; i<entry; i++)
                pActEntry = pActEntry->Next;
            for (i=0; i<row; i++)
                pActEntry = pActEntry->Next;
            strcpy(in,pActEntry->Nodestr);

            /* Free all allocated Menory */
            pActEntry = &SelEntry;
            /* first go to end of entrys */
            while (pActEntry->Next != NULL)
            {
                pActEntry = pActEntry->Next;
            } /* endwhile */
            /* Now, free the list from end to top */
            /* dont free the first one, its allocated on stack */
            while (pActEntry->Priv)
            {
               pActEntry = pActEntry->Priv;
               free(pActEntry->Next);
            } /* endwhile */
            sb_restore(p);
        }
    }
    return(ret);
}
