/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*              (C) Copyright 1987-96, Bit Bucket Software Co.              */
/*                                                                          */
/*                                                                          */
/*                                                                          */
/*                    BinkleyTerm SRIF implementation                       */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.260.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:42/1491                        */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*--------------------------------------------------------------------------*/

#include "includes.h"


int invoke_SRIF(int f_sent, int (*callback) (char *), int (*calltime) (long))
{
  int fsent = f_sent, good;
  char req[PATHLEN], command[PATHLEN], name[PATHLEN];
  char *s, resp[PATHLEN], sname[PATHLEN];
  int np;
  ADDR foo;
  FILE *srif;

  calltime=calltime; /* MMP 960513 Keep compiler happy */

  /* calculating the req-name */
  for (np = 0; np <= ALIAS_CNT; np++)
        {
                foo = alias[np];

                if (foo.Net == 0)
                        break;

                /* For a point, massage the address to get the right .REQ filename */

                if (foo.Point != 0)
                {
                        foo.Node = foo.Point;
                        foo.Point = 0;
                        foo.Net = (pvtnet > 0) ? (word) pvtnet : 0;
                }

                (void) sprintf (req, request_template, CURRENT.sc_Inbound, Hex_Addr_Str (&foo), TaskNumber);
                if (!dexists(req)) continue; /* on this aka is no request */

                sprintf(sname, "srif.%02x", TaskNumber);
                srif = fopen(sname, write_ascii);
                if (srif == NULL) goto done;
                fprintf(srif, "Sysop %s\n", remote_sysop);
                fprintf(srif, "AKA %u:%u/%u.%u\n", remote_addr.Zone, remote_addr.Net, remote_addr.Node, remote_addr.Point);
                fprintf(srif, "Baud %lu\n", cur_baud.rate_value); /* TS/TJW 960620 */ 
                fprintf(srif, "Time %d\n", time_to_next(0));
                fprintf(srif, "RequestList %s\n", req);
                sprintf(resp, "%s%s.QLO",                     /* TJW 960528 */
                              HoldAreaNameMunge(&remote_addr),
                              Hex_Addr_Str(&remote_addr));
                fprintf(srif, "ResponseList %s\n",resp);
                fprintf(srif, "RemoteStatus %srotected\n", is_protected ? "P" : "Unp");
                fprintf(srif, "SystemStatus %sisted\n", is_listed ? "L" : "Unl");
                fprintf(srif, "Site %s\n", remote_site);
                fprintf(srif, "Location %s\n", remote_location);
                fprintf(srif, "Phone %s\n", remote_phone);
                fprintf(srif, "Mailer %s\n", remote_mailer);
                fprintf(srif, "Port %d\n", original_port);
                if (is_protected && strlen(password))
                  fprintf(srif, "Password %s\n", password);
                fclose(srif);
                
                /* Spawn to SRIF ERP */
                sprintf(command, SRIF_commandline, sname);
                status_line( MSG_TXT(M_SRIF_INVOKE), command);
                b_spawn(command);

                /* TJW 960430 redraw screen */
                sb_dirty();
                sb_show();

                unlink(sname); /* kill srif and request-file */
                unlink(req);

                if ((srif=fopen(resp, read_ascii))!=NULL) {

                  while (!feof(srif))
                    {
                       req[0] = 0;
                        if (fgets(req, 79, srif)==NULL) break;
                       /* ; as the first char is a comment */
                       if (req[0] == ';') continue;

                       /* Get rid of the newline at the end */
                       s = (char *) (req + strlen (req) - 1);
                       while ((s >= req) && isspace (*s))
                              *s-- = '\0';

                       if (req[0] == '\0')
                            continue;
                       s = req;
                       switch (req[0]) {
                          case '^' :
                          case '-' :
                          case '+' :
                          case '=' : s++;
                                     break;
                          default :
                                     break;
                       }
                       strcpy(name, s);
                       good = callback(name);

                       switch (req[0]) {
                          case '=' : if (!good) break;
                          case '^' : /* fall-through ... */
                          case '-' : unlink(name);
                                     break;
                       }
                    }
                  }

                fclose(srif);
                unlink(resp);
        }
done:
  return fsent;
}
